searchData={"items":[{"type":"module","title":"Vivid","doc":"Vivid is a 2D rendering engine implemented purely in Elixir.\n\nIf you add `use Vivid` to your module then aliases for all the common Vivid\nmodules will automatically be defined for you.","ref":"Vivid.html"},{"type":"module","title":"Examples - Vivid","doc":"Drawing a box on the frame\n\n    iex> use Vivid\n    ...> frame = Frame.init(40, 20, RGBA.white)\n    ...> box   = Box.init(Point.init(2,2), Point.init(12,12))\n    ...> frame\n    ...>   |> Frame.push(box, RGBA.black)\n    ...>   |> to_string\n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@           @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@           @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"\n\n  And now add a circle.\n\n    iex> use Vivid\n    ...> frame  = Frame.init(40, 20, RGBA.white)\n    ...> box    = Box.init(Point.init(2,2), Point.init(12,12))\n    ...> circle = Circle.init(Point.init(20, 10), 5)\n    ...> frame\n    ...>   |> Frame.push(box, RGBA.black)\n    ...>   |> Frame.push(circle, RGBA.init(0.5, 0.5, 0.5, 1))\n    ...>   |> to_string\n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@:::::@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@:@@@@@:@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@:@@@@@@@:@@@@@@@@@@@@@@@\\n\"  \n    \"@@           @@@:@@@@@@@:@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@:@@@@@@@@@:@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@:@@@@@@@@@:@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@:@@@@@@@@@:@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@:@@@@@@@:@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@:@@@@@@@:@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@:@@@@@:@@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@:::::@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@           @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"\n\n  And now a triangle.\n\n    iex> use Vivid\n    ...> frame    = Frame.init(40, 20, RGBA.white)\n    ...> box      = Box.init(Point.init(2,2), Point.init(12,12))\n    ...> circle   = Circle.init(Point.init(20, 10), 5)\n    ...> triangle = Circle.init(Point.init(30, 7), 5)\n    ...>   |> Circle.to_polygon(3)\n    ...> frame\n    ...>   |> Frame.push(box, RGBA.black)\n    ...>   |> Frame.push(circle, RGBA.init(0.5, 0.5, 0.5, 1))\n    ...>   |> Frame.push(triangle, RGBA.init(0.8, 0.8, 0.8, 1))\n    ...>   |> to_string\n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@:::::@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@:@@@@@:@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@:@@@@@@@:@@@@@@@@@@@@@@@\\n\"  \n    \"@@           @@@:@@@@@@@:@@@@@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@:@@@@@@@@@:@**@@@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@:@@@@@@@@@:@*@**@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@:@@@@@@@@@:@*@@@**@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@:@@@@@@@:@@*@@@@@**@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@:@@@@@@@:@@@*@@@@@@*@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@:@@@@@:@@@@*@@@@**@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@:::::@@@@@*@@**@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@***@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@@@@@@@@@@@*@@@@@@@@@@@\\n\"  \n    \"@@           @@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"\n\n  And rotate the box.\n\n    iex> use Vivid\n    ...> frame    = Frame.init(40, 20, RGBA.white)\n    ...> box      = Box.init(Point.init(2,2), Point.init(12,12))\n    ...>   |> Transform.rotate(45)\n    ...>   |> Transform.apply\n    ...> circle   = Circle.init(Point.init(20, 10), 5)\n    ...> triangle = Circle.init(Point.init(30, 7), 5)\n    ...>   |> Circle.to_polygon(3)\n    ...> frame\n    ...>   |> Frame.push(box, RGBA.black)\n    ...>   |> Frame.push(circle, RGBA.init(0.5, 0.5, 0.5, 1))\n    ...>   |> Frame.push(triangle, RGBA.init(0.8, 0.8, 0.8, 1))\n    ...>   |> to_string\n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@:::::@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@ @@@@@@@@@:@@@@@:@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@ @ @@@@@@@:@@@@@@@:@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@ @@@ @@@@@@:@@@@@@@:@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@ @@@@@ @@@@:@@@@@@@@@:@**@@@@@@@@@@@\\n\"  \n    \"@@@ @@@@@@@ @@@:@@@@@@@@@:@*@**@@@@@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@:@@@@@@@@@:@*@@@**@@@@@@@\\n\"  \n    \"@ @@@@@@@@@@@ @@:@@@@@@@:@@*@@@@@**@@@@@\\n\"  \n    \" @@@@@@@@@@@@@ @:@@@@@@@:@@@*@@@@@@*@@@@\\n\"  \n    \"@ @@@@@@@@@@@ @@@:@@@@@:@@@@*@@@@**@@@@@\\n\"  \n    \"@@ @@@@@@@@@ @@@@@:::::@@@@@*@@**@@@@@@@\\n\"  \n    \"@@@ @@@@@@@ @@@@@@@@@@@@@@@@***@@@@@@@@@\\n\"  \n    \"@@@@ @@@@@ @@@@@@@@@@@@@@@@@*@@@@@@@@@@@\\n\"  \n    \"@@@@@ @@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@ @ @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"\n\n  And apply a bunch of arbitrary transformations\n\n    iex> use Vivid\n    ...> frame    = Frame.init(40, 20, RGBA.white)\n    ...> box      = Box.init(Point.init(2,2), Point.init(12,12))\n    ...>   |> Transform.rotate(45)\n    ...>   |> Transform.scale(0.75)\n    ...>   |> Transform.translate(10, 10)\n    ...>   |> Transform.apply\n    ...> circle   = Circle.init(Point.init(20, 10), 5)\n    ...>   |> Transform.fill(frame)\n    ...>   |> Transform.center(frame)\n    ...>   |> Transform.apply\n    ...> triangle = Circle.init(Point.init(30, 7), 5)\n    ...>   |> Circle.to_polygon(3)\n    ...>   |> Transform.scale(1.5)\n    ...>   |> Transform.apply\n    ...> frame\n    ...>   |> Frame.push(box, RGBA.black)\n    ...>   |> Frame.push(circle, RGBA.init(0.5, 0.5, 0.5, 1))\n    ...>   |> Frame.push(triangle, RGBA.init(0.8, 0.8, 0.8, 1))\n    ...>   |> to_string\n    \"@@@@@@@@@@@@@@ @:::: :::@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@ @:@@@@@ @@:@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@ ::@@@@@@@ @@::@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@: @@@@@@@ @@@@@:@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@:@@ @@@@@ @@@@@@@:@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@:@@@ @@@ @@@@@@@@:@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@:@@@@ @ @@@@@@@*@:@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@:@@@@@@ @@@@@@@@***:@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@:@@@@@@@@@@@@@@@*@@:*@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@:@@@@@@@@@@@@@@@*@@:@**@@@@@@@\\n\"  \n    \"@@@@@@@@@@:@@@@@@@@@@@@@@@*@@:@@@**@@@@@\\n\"  \n    \"@@@@@@@@@@:@@@@@@@@@@@@@@@*@@:@@@@@**@@@\\n\"  \n    \"@@@@@@@@@@@:@@@@@@@@@@@@@@*@:@@@@@@@@*@@\\n\"  \n    \"@@@@@@@@@@@:@@@@@@@@@@@@@@*@:@@@@@@**@@@\\n\"  \n    \"@@@@@@@@@@@:@@@@@@@@@@@@@@*@:@@@@**@@@@@\\n\"  \n    \"@@@@@@@@@@@:@@@@@@@@@@@@@@*@:@@**@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@:@@@@@@@@@@@@@*:@**@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@::@@@@@@@@@@::**@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@:@@@@@@@@:@*@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@::::::::@@@@@@@@@@@@@@@@\\n\"","ref":"Vivid.html#module-examples"},{"type":"module","title":"Vivid.Arc","doc":"This module represents an Arc, otherwise known as a circle segment.","ref":"Vivid.Arc.html"},{"type":"module","title":"Example - Vivid.Arc","doc":"iex> use Vivid\n    ...> Arc.init(Point.init(10,10), 10, 0, 45)\n    ...> |> to_string()\n    \"@@@@@@\\n\"  \n    \"@@@  @\\n\"  \n    \"@@@ @@\\n\"  \n    \"@@ @@@\\n\"  \n    \"@@ @@@\\n\"  \n    \"@  @@@\\n\"  \n    \"@ @@@@\\n\"  \n    \"@ @@@@\\n\"  \n    \"@ @@@@\\n\"  \n    \"@@@@@@\\n\"","ref":"Vivid.Arc.html#module-example"},{"type":"function","title":"Vivid.Arc.center/1","doc":"Returns the center point of an `arc`.","ref":"Vivid.Arc.html#center/1"},{"type":"function","title":"Example - Vivid.Arc.center/1","doc":"iex> Vivid.Arc.init(Vivid.Point.init(10,10), 5, 0, 90, 12)\n    ...> |> Vivid.Arc.center\n    Vivid.Point.init(10, 10)","ref":"Vivid.Arc.html#center/1-example"},{"type":"function","title":"Vivid.Arc.center/2","doc":"Changes the center `point` of `arc`.","ref":"Vivid.Arc.html#center/2"},{"type":"function","title":"Example - Vivid.Arc.center/2","doc":"iex> Vivid.Arc.init(Vivid.Point.init(10,10), 5, 0, 90, 12)\n    ...> |> Vivid.Arc.center(Vivid.Point.init(15,15))\n    ...> |> Vivid.Arc.center\n    Vivid.Point.init(15, 15)","ref":"Vivid.Arc.html#center/2-example"},{"type":"function","title":"Vivid.Arc.init/5","doc":"Creates an Arc.\n\n* `center` is a Point definining the center point of the arc's parent circle.\n* `radius` is the radius of the parent circle.\n* `start_angle` is the angle at which to start drawing the arc, `0` is the parallel to the X axis, to the left.\n* `range` is the number of degrees to draw the arc.\n* `steps` the arc is drawn by dividing it into a number of lines. Defaults to 12.","ref":"Vivid.Arc.html#init/5"},{"type":"function","title":"Examples - Vivid.Arc.init/5","doc":"iex> Vivid.Arc.init(Vivid.Point.init(5,5), 4, 45, 15)\n    %Vivid.Arc{\n      center:      %Vivid.Point{x: 5, y: 5},\n      radius:      4,\n      start_angle: 45,\n      range:       15,\n      steps:       12\n    }","ref":"Vivid.Arc.html#init/5-examples"},{"type":"function","title":"Vivid.Arc.radius/1","doc":"Returns the radius of an `arc`.","ref":"Vivid.Arc.html#radius/1"},{"type":"function","title":"Example - Vivid.Arc.radius/1","doc":"iex> Vivid.Arc.init(Vivid.Point.init(10,10), 5, 0, 90, 12)\n    ...> |> Vivid.Arc.radius\n    5","ref":"Vivid.Arc.html#radius/1-example"},{"type":"function","title":"Vivid.Arc.radius/2","doc":"Change the `radius` of `arc`.","ref":"Vivid.Arc.html#radius/2"},{"type":"function","title":"Example - Vivid.Arc.radius/2","doc":"iex> Vivid.Arc.init(Vivid.Point.init(10,10), 5, 0, 90, 12)\n    ...> |> Vivid.Arc.radius(10)\n    ...> |> Vivid.Arc.radius\n    10","ref":"Vivid.Arc.html#radius/2-example"},{"type":"function","title":"Vivid.Arc.range/1","doc":"Returns the range of the `arc`.","ref":"Vivid.Arc.html#range/1"},{"type":"function","title":"Example - Vivid.Arc.range/1","doc":"iex> Vivid.Arc.init(Vivid.Point.init(10,10), 5, 0, 90, 12)\n    ...> |> Vivid.Arc.range\n    90","ref":"Vivid.Arc.html#range/1-example"},{"type":"function","title":"Vivid.Arc.range/2","doc":"Change the range of an `arc`.","ref":"Vivid.Arc.html#range/2"},{"type":"function","title":"Example - Vivid.Arc.range/2","doc":"iex> Vivid.Arc.init(Vivid.Point.init(10,10), 5, 0, 90, 12)\n    ...> |> Vivid.Arc.range(270)\n    ...> |> Vivid.Arc.range\n    270","ref":"Vivid.Arc.html#range/2-example"},{"type":"function","title":"Vivid.Arc.start_angle/1","doc":"Returns the start angle of an `arc`.","ref":"Vivid.Arc.html#start_angle/1"},{"type":"function","title":"Example - Vivid.Arc.start_angle/1","doc":"iex> Vivid.Arc.init(Vivid.Point.init(10,10), 5, 0, 90, 12)\n    ...> |> Vivid.Arc.start_angle\n    0","ref":"Vivid.Arc.html#start_angle/1-example"},{"type":"function","title":"Vivid.Arc.start_angle/2","doc":"Change the start angle of an `arc`.","ref":"Vivid.Arc.html#start_angle/2"},{"type":"function","title":"Example - Vivid.Arc.start_angle/2","doc":"iex> Vivid.Arc.init(Vivid.Point.init(10,10), 5, 0, 90, 12)\n    ...> |> Vivid.Arc.start_angle(45)\n    ...> |> Vivid.Arc.start_angle\n    45","ref":"Vivid.Arc.html#start_angle/2-example"},{"type":"function","title":"Vivid.Arc.steps/1","doc":"Returns the number of steps in the `arc`.","ref":"Vivid.Arc.html#steps/1"},{"type":"function","title":"Example - Vivid.Arc.steps/1","doc":"iex> Vivid.Arc.init(Vivid.Point.init(10,10), 5, 0, 90, 12)\n    ...> |> Vivid.Arc.steps\n    12","ref":"Vivid.Arc.html#steps/1-example"},{"type":"function","title":"Vivid.Arc.steps/2","doc":"Changes the number of `steps` in `arc`.","ref":"Vivid.Arc.html#steps/2"},{"type":"function","title":"Example - Vivid.Arc.steps/2","doc":"iex> Vivid.Arc.init(Vivid.Point.init(10,10), 5, 0, 90, 12)\n    ...> |> Vivid.Arc.steps(19)\n    ...> |> Vivid.Arc.steps\n    19","ref":"Vivid.Arc.html#steps/2-example"},{"type":"function","title":"Vivid.Arc.to_path/1","doc":"Converts the `arc` into a Path, which is used for a bunch of things like\nTransforms, Bounds calculation, Rasterization, etc.","ref":"Vivid.Arc.html#to_path/1"},{"type":"function","title":"Example - Vivid.Arc.to_path/1","doc":"iex> Vivid.Arc.init(Vivid.Point.init(10,10), 5, 0, 90, 3)\n    ...> |> Vivid.Arc.to_path\n    Vivid.Path.init([Vivid.Point.init(5, 10), Vivid.Point.init(6, 13), Vivid.Point.init(8, 14), Vivid.Point.init(10, 15)])","ref":"Vivid.Arc.html#to_path/1-example"},{"type":"type","title":"Vivid.Arc.t/0","doc":"","ref":"Vivid.Arc.html#t:t/0"},{"type":"module","title":"Vivid.Bounds","doc":"Provides information about the bounds of a box and pixel positions within it.","ref":"Vivid.Bounds.html"},{"type":"module","title":"Example - Vivid.Bounds","doc":"iex> use Vivid\n  ...> Box.init(Point.init(5,10),Point.init(15,20))\n  ...> |> Bounds.bounds()\n  %Vivid.Bounds{min: Vivid.Point.init(5, 10), max: Vivid.Point.init(15, 20)}","ref":"Vivid.Bounds.html#module-example"},{"type":"function","title":"Vivid.Bounds.bounds/1","doc":"Return the bounding box required to encapsulate the shape.\n\n* `shape` - A shape whose bounds you want to measure.","ref":"Vivid.Bounds.html#bounds/1"},{"type":"function","title":"Example - Vivid.Bounds.bounds/1","doc":"iex> Vivid.Circle.init(Vivid.Point.init(10,10), 10)\n    ...> |> Vivid.Bounds.bounds\n    %Vivid.Bounds{min: Vivid.Point.init(0.0, 0.0), max: Vivid.Point.init(20.0, 20.0)}","ref":"Vivid.Bounds.html#bounds/1-example"},{"type":"function","title":"Vivid.Bounds.center_of/1","doc":"Returns the center point of the bounds.\n\n* `shape` - The shape whose center-most pixel you want to find.","ref":"Vivid.Bounds.html#center_of/1"},{"type":"function","title":"Example - Vivid.Bounds.center_of/1","doc":"iex> Vivid.Circle.init(Vivid.Point.init(10,10), 10)\n    ...> |> Vivid.Circle.to_polygon\n    ...> |> Vivid.Bounds.center_of\n    Vivid.Point.init(10.0, 10.0)","ref":"Vivid.Bounds.html#center_of/1-example"},{"type":"function","title":"Vivid.Bounds.contains?/2","doc":"Returns true if the point is within the bounds.\n\n* `shape` - A shape you wish to test.\n* `point` - The point you wish to test.","ref":"Vivid.Bounds.html#contains?/2"},{"type":"function","title":"Examples - Vivid.Bounds.contains?/2","doc":"iex> Vivid.Bounds.init(0, 0, 10, 10)\n      ...> |> Vivid.Bounds.contains?(Vivid.Point.init(0, 0))\n      true\n\n      iex> Vivid.Bounds.init(0, 0, 10, 10)\n      ...> |> Vivid.Bounds.contains?(Vivid.Point.init(5, 5))\n      true\n\n      iex> Vivid.Bounds.init(0, 0, 10, 10)\n      ...> |> Vivid.Bounds.contains?(Vivid.Point.init(-1, -1))\n      false\n\n      iex> Vivid.Bounds.init(0, 0, 10, 10)\n      ...> |> Vivid.Bounds.contains?(Vivid.Point.init(-10, -10))\n      false\n\n      iex> Vivid.Bounds.init(0, 0, 10, 10)\n      ...> |> Vivid.Bounds.contains?(Vivid.Point.init(10, 10))\n      true\n\n      iex> Vivid.Bounds.init(0, 0, 10, 10)\n      ...> |> Vivid.Bounds.contains?(Vivid.Point.init(11, 11))\n      false","ref":"Vivid.Bounds.html#contains?/2-examples"},{"type":"function","title":"Vivid.Bounds.height/1","doc":"Returns the height of a shape.\n\n* `shape` - The shape whose height you want to measure.","ref":"Vivid.Bounds.html#height/1"},{"type":"function","title":"Example - Vivid.Bounds.height/1","doc":"iex> Vivid.Circle.init(Vivid.Point.init(10,10), 10)\n    ...> |> Vivid.Bounds.height\n    20.0","ref":"Vivid.Bounds.html#height/1-example"},{"type":"function","title":"Vivid.Bounds.init/4","doc":"Initialise arbitrary bounds.\n\n* `x0` - The x coordinate of the bottom-left pixel.\n* `y0` - The y coordinate of the bottom-left pixel.\n* `x1` - The x coordinate of the top-right pixel.\n* `y1` - The y coordinate of the top-right pixel.","ref":"Vivid.Bounds.html#init/4"},{"type":"function","title":"Example - Vivid.Bounds.init/4","doc":"iex> Vivid.Bounds.init(0, 0, 5, 5)\n    %Vivid.Bounds{min: Vivid.Point.init(0, 0), max: Vivid.Point.init(5, 5)}","ref":"Vivid.Bounds.html#init/4-example"},{"type":"function","title":"Vivid.Bounds.max/1","doc":"Returns the top-right point of the bounds.\n\n* `shape` - The shape whose top-right pixel you want to find.","ref":"Vivid.Bounds.html#max/1"},{"type":"function","title":"Example - Vivid.Bounds.max/1","doc":"iex> Vivid.Circle.init(Vivid.Point.init(10,10), 10)\n    ...> |> Vivid.Bounds.max\n    Vivid.Point.init(20.0, 20.0)","ref":"Vivid.Bounds.html#max/1-example"},{"type":"function","title":"Vivid.Bounds.min/1","doc":"Returns the bottom-left point of the bounds.\n\n* `shape` - The shape whose bottom-left pixel you want to find.","ref":"Vivid.Bounds.html#min/1"},{"type":"function","title":"Example - Vivid.Bounds.min/1","doc":"iex> Vivid.Circle.init(Vivid.Point.init(10,10), 10)\n    ...> |> Vivid.Bounds.min\n    Vivid.Point.init(0.0, 0.0)","ref":"Vivid.Bounds.html#min/1-example"},{"type":"function","title":"Vivid.Bounds.width/1","doc":"Returns the width of a shape.\n\n* `shape` - The shape whose width you want to measure.","ref":"Vivid.Bounds.html#width/1"},{"type":"function","title":"Example - Vivid.Bounds.width/1","doc":"iex> Vivid.Circle.init(Vivid.Point.init(10,10), 10)\n    ...> |> Vivid.Bounds.width\n    20.0","ref":"Vivid.Bounds.html#width/1-example"},{"type":"type","title":"Vivid.Bounds.t/0","doc":"","ref":"Vivid.Bounds.html#t:t/0"},{"type":"protocol","title":"Vivid.Bounds.Of","doc":"This protocol is used to calculate the bounds of a given shape.\n\nImplement this protocol if you are defining any new shape types.","ref":"Vivid.Bounds.Of.html"},{"type":"function","title":"Vivid.Bounds.Of.bounds/1","doc":"Return the bounds of a Shape as a two element tuple of bottom-left and\ntop-right points.","ref":"Vivid.Bounds.Of.html#bounds/1"},{"type":"type","title":"Vivid.Bounds.Of.t/0","doc":"All the types that implement this protocol.","ref":"Vivid.Bounds.Of.html#t:t/0"},{"type":"module","title":"Vivid.Box","doc":"Short-hand for creating rectangle polygons.\n\nThis module doesn't have very much logic other than knowing how to\nturn itself into a Polygon.","ref":"Vivid.Box.html"},{"type":"module","title":"Example - Vivid.Box","doc":"iex> use Vivid\n    ...> Box.init(Point.init(5,10), Point.init(15,20))\n    ...> |> to_string()\n    \"@@@@@@@@@@@@@\\n\"  \n    \"@           @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@           @\\n\"  \n    \"@@@@@@@@@@@@@\\n\"","ref":"Vivid.Box.html#module-example"},{"type":"function","title":"Vivid.Box.bottom_left/1","doc":"Return the bottom left corner of the box.","ref":"Vivid.Box.html#bottom_left/1"},{"type":"function","title":"Example - Vivid.Box.bottom_left/1","doc":"iex> use Vivid\n    ...> Box.init(Point.init(1,1), Point.init(4,4))\n    ...> |> Box.bottom_left\n    Point.init(1, 1)","ref":"Vivid.Box.html#bottom_left/1-example"},{"type":"function","title":"Vivid.Box.bottom_right/1","doc":"Return the top right corner of the box.","ref":"Vivid.Box.html#bottom_right/1"},{"type":"function","title":"Example - Vivid.Box.bottom_right/1","doc":"iex> use Vivid\n    ...> Box.init(Point.init(1,1), Point.init(4,4))\n    ...> |> Box.bottom_right\n    Point.init(4, 1)","ref":"Vivid.Box.html#bottom_right/1-example"},{"type":"function","title":"Vivid.Box.init/2","doc":"Initialize an unfilled Box from it's bottom left and top right points.\n\n* `bottom_left` - the bottom left `Point` of the box.\n* `top_right` - the top right `Point` of the box.","ref":"Vivid.Box.html#init/2"},{"type":"function","title":"Examples - Vivid.Box.init/2","doc":"iex> use Vivid\n    ...> Box.init(Point.init(1,1), Point.init(4,4))\n    %Box{bottom_left: Point.init(1, 1), top_right: Point.init(4, 4)}","ref":"Vivid.Box.html#init/2-examples"},{"type":"function","title":"Vivid.Box.init/3","doc":"Initialize a Box from it's bottom left and top right points and whether it's filled.\n\n* `bottom_left` - the bottom left `Point` of the box.\n* `top_right` - the top right `Point` of the box.\n* `fill` - whether or not the box should be filled.","ref":"Vivid.Box.html#init/3"},{"type":"function","title":"Examples - Vivid.Box.init/3","doc":"iex> use Vivid\n    ...> Box.init(Point.init(1,1), Point.init(4,4))\n    %Box{bottom_left: Point.init(1, 1), top_right: Point.init(4, 4)}","ref":"Vivid.Box.html#init/3-examples"},{"type":"function","title":"Vivid.Box.init_from_bounds/2","doc":"Initialize a box from the bounds of an arbitrary shape.","ref":"Vivid.Box.html#init_from_bounds/2"},{"type":"function","title":"Examples - Vivid.Box.init_from_bounds/2","doc":"iex> use Vivid\n    ...> Circle.init(Point.init(5,5), 5)\n    ...> |> Box.init_from_bounds\n    Box.init(Point.init(0.0, 0.2447174185242318), Point.init(10.0, 9.755282581475768))","ref":"Vivid.Box.html#init_from_bounds/2-examples"},{"type":"function","title":"Vivid.Box.to_polygon/1","doc":"Convert a Box into a Polygon.","ref":"Vivid.Box.html#to_polygon/1"},{"type":"function","title":"Example - Vivid.Box.to_polygon/1","doc":"iex> use Vivid\n    ...> Box.init(Point.init(1,1), Point.init(4,4))\n    ...> |> Box.to_polygon\n    Polygon.init([Point.init(1, 1), Point.init(1, 4), Point.init(4, 4), Point.init(4, 1)])","ref":"Vivid.Box.html#to_polygon/1-example"},{"type":"function","title":"Vivid.Box.top_left/1","doc":"Return the top left corner of the box.","ref":"Vivid.Box.html#top_left/1"},{"type":"function","title":"Example - Vivid.Box.top_left/1","doc":"iex> use Vivid\n    ...> Box.init(Point.init(1,1), Point.init(4,4))\n    ...> |> Box.top_left\n    Point.init(1, 4)","ref":"Vivid.Box.html#top_left/1-example"},{"type":"function","title":"Vivid.Box.top_right/1","doc":"Return the top right corner of the box.","ref":"Vivid.Box.html#top_right/1"},{"type":"function","title":"Example - Vivid.Box.top_right/1","doc":"iex> use Vivid\n    ...> Box.init(Point.init(1,1), Point.init(4,4))\n    ...> |> Box.top_right\n    Point.init(4, 4)","ref":"Vivid.Box.html#top_right/1-example"},{"type":"type","title":"Vivid.Box.t/0","doc":"","ref":"Vivid.Box.html#t:t/0"},{"type":"module","title":"Vivid.Buffer","doc":"Used to convert a Frame into a buffer for display.\n\nYou're unlikely to need to use this module directly, instead you will\nlikely want to use `Frame.buffer/2` instead.\n\nBuffer implements the `Enumerable` protocol.","ref":"Vivid.Buffer.html"},{"type":"module","title":"Example - Vivid.Buffer","doc":"iex> use Vivid\n    ...> box = Box.init(Point.init(1,1), Point.init(18,8))\n    ...> Frame.init(20, 10, RGBA.white())\n    ...> |> Frame.push(box, RGBA.black())\n    ...> |> Buffer.horizontal()\n    ...> |> Stream.chunk_every(20)\n    ...> |> Stream.map(fn line ->\n    ...>   Stream.map(line, fn colour -> RGBA.to_ascii(colour) end)\n    ...>   |> Enum.join()\n    ...> end)\n    ...> |> Enum.join(\"\\n\")\n    \"@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@                  @\\n\"  \n    \"@ @@@@@@@@@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@@@@@@@@ @\\n\"  \n    \"@                  @\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@\"","ref":"Vivid.Buffer.html#module-example"},{"type":"function","title":"Vivid.Buffer.columns/1","doc":"Returns the number of columns in the buffer.","ref":"Vivid.Buffer.html#columns/1"},{"type":"function","title":"Vivid.Buffer.horizontal/1","doc":"Render the buffer horizontally, ie across rows then up columns.","ref":"Vivid.Buffer.html#horizontal/1"},{"type":"function","title":"Example - Vivid.Buffer.horizontal/1","doc":"iex> use Vivid\n    ...> Frame.init(5, 5, RGBA.white)\n    ...> |> Frame.push(Line.init(Point.init(0, 2), Point.init(5, 2)), RGBA.black)\n    ...> |> Buffer.horizontal\n    ...> |> to_string\n    \"@@@@@\\n\"  \n    \"@@@@@\\n\"  \n    \"     \\n\"  \n    \"@@@@@\\n\"  \n    \"@@@@@\\n\"","ref":"Vivid.Buffer.html#horizontal/1-example"},{"type":"function","title":"Vivid.Buffer.rows/1","doc":"Returns the number of rows in the buffer.","ref":"Vivid.Buffer.html#rows/1"},{"type":"function","title":"Vivid.Buffer.vertical/1","doc":"Render the buffer vertically, ie up columns then across rows.","ref":"Vivid.Buffer.html#vertical/1"},{"type":"function","title":"Example - Vivid.Buffer.vertical/1","doc":"iex> use Vivid\n    ...> Frame.init(5, 5, RGBA.white)\n    ...> |> Frame.push(Line.init(Point.init(0, 2), Point.init(5, 2)), RGBA.black)\n    ...> |> Buffer.vertical\n    ...> |> to_string\n    \"@@ @@\\n\"  \n    \"@@ @@\\n\"  \n    \"@@ @@\\n\"  \n    \"@@ @@\\n\"  \n    \"@@ @@\\n\"","ref":"Vivid.Buffer.html#vertical/1-example"},{"type":"type","title":"Vivid.Buffer.t/0","doc":"","ref":"Vivid.Buffer.html#t:t/0"},{"type":"module","title":"Vivid.Circle","doc":"Represents a circle based on it's center point and radius.","ref":"Vivid.Circle.html"},{"type":"module","title":"Example - Vivid.Circle","doc":"iex> use Vivid\n  ...> Circle.init(Point.init(10,10), 10)\n  ...> |> to_string()\n  \"@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n  \"@@@@@@@@       @@@@@@@@\\n\"  \n  \"@@@@@@  @@@@@@@  @@@@@@\\n\"  \n  \"@@@@@ @@@@@@@@@@@ @@@@@\\n\"  \n  \"@@@@ @@@@@@@@@@@@@ @@@@\\n\"  \n  \"@@@ @@@@@@@@@@@@@@@ @@@\\n\"  \n  \"@@ @@@@@@@@@@@@@@@@@ @@\\n\"  \n  \"@@ @@@@@@@@@@@@@@@@@ @@\\n\"  \n  \"@ @@@@@@@@@@@@@@@@@@@ @\\n\"  \n  \"@ @@@@@@@@@@@@@@@@@@@ @\\n\"  \n  \"@ @@@@@@@@@@@@@@@@@@@ @\\n\"  \n  \"@ @@@@@@@@@@@@@@@@@@@ @\\n\"  \n  \"@ @@@@@@@@@@@@@@@@@@@ @\\n\"  \n  \"@ @@@@@@@@@@@@@@@@@@@ @\\n\"  \n  \"@ @@@@@@@@@@@@@@@@@@@ @\\n\"  \n  \"@@ @@@@@@@@@@@@@@@@@ @@\\n\"  \n  \"@@ @@@@@@@@@@@@@@@@@ @@\\n\"  \n  \"@@@ @@@@@@@@@@@@@@@ @@@\\n\"  \n  \"@@@@ @@@@@@@@@@@@@ @@@@\\n\"  \n  \"@@@@@ @@@@@@@@@@@ @@@@@\\n\"  \n  \"@@@@@@  @@@@@@@  @@@@@@\\n\"  \n  \"@@@@@@@@       @@@@@@@@\\n\"  \n  \"@@@@@@@@@@@@@@@@@@@@@@@\\n\"","ref":"Vivid.Circle.html#module-example"},{"type":"function","title":"Vivid.Circle.center/1","doc":"Returns the center point of a circle.","ref":"Vivid.Circle.html#center/1"},{"type":"function","title":"Example - Vivid.Circle.center/1","doc":"iex> Vivid.Circle.init(Vivid.Point.init(5,5), 4)\n    ...> |> Vivid.Circle.center\n    %Vivid.Point{x: 5, y: 5}","ref":"Vivid.Circle.html#center/1-example"},{"type":"function","title":"Vivid.Circle.circumference/1","doc":"Returns the circumference of a circle.","ref":"Vivid.Circle.html#circumference/1"},{"type":"function","title":"Example - Vivid.Circle.circumference/1","doc":"iex> Vivid.Circle.init(Vivid.Point.init(5,5), 4)\n    ...> |> Vivid.Circle.circumference\n    25.132741228718345","ref":"Vivid.Circle.html#circumference/1-example"},{"type":"function","title":"Vivid.Circle.init/2","doc":"Creates a circle from a point in 2D space and a radius.","ref":"Vivid.Circle.html#init/2"},{"type":"function","title":"Example - Vivid.Circle.init/2","doc":"iex> Vivid.Circle.init(Vivid.Point.init(5,5), 4)\n    %Vivid.Circle{center: Vivid.Point.init(5, 5), radius: 4}","ref":"Vivid.Circle.html#init/2-example"},{"type":"function","title":"Vivid.Circle.radius/1","doc":"Returns the radius of a circle.","ref":"Vivid.Circle.html#radius/1"},{"type":"function","title":"Example - Vivid.Circle.radius/1","doc":"iex> Vivid.Circle.init(Vivid.Point.init(5,5), 4)\n    ...> |> Vivid.Circle.radius\n    4","ref":"Vivid.Circle.html#radius/1-example"},{"type":"function","title":"Vivid.Circle.to_polygon/1","doc":"Convert the `circle` into a Polygon.\n\nWe convert a circle into a Polygon whenever we Transform or render it, so\nsometimes it might be worth doing it yourself and specifying how many vertices\nthe polygon should have.\n\nWhen unspecified `steps` is set to the diameter of the circle rounded to\nthe nearest integer.","ref":"Vivid.Circle.html#to_polygon/1"},{"type":"function","title":"Examples - Vivid.Circle.to_polygon/1","doc":"iex> use Vivid\n    ...> Circle.init(Point.init(5,5), 5)\n    ...> |> Circle.to_polygon\n    ...> |> to_string\n    \"@@@@@@@@@@@@@\\n\"  \n    \"@@@@     @@@@\\n\"  \n    \"@@@ @@@@@ @@@\\n\"  \n    \"@@ @@@@@@@ @@\\n\"  \n    \"@@ @@@@@@@ @@\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@@ @@@@@@@ @@\\n\"  \n    \"@@ @@@@@@@ @@\\n\"  \n    \"@@@ @@@@@ @@@\\n\"  \n    \"@@@@     @@@@\\n\"  \n    \"@@@@@@@@@@@@@\\n\"","ref":"Vivid.Circle.html#to_polygon/1-examples"},{"type":"function","title":"Vivid.Circle.to_polygon/2","doc":"Convert the `circle` into a Polygon with a specific number of vertices.\n\nWe convert a circle into a Polygon whenever we Transform or render it, so\nsometimes it might be worth doing it yourself and specifying how many vertices\nthe polygon should have.","ref":"Vivid.Circle.html#to_polygon/2"},{"type":"function","title":"Examples - Vivid.Circle.to_polygon/2","doc":"iex> use Vivid\n    ...> Circle.init(Point.init(5,5), 5)\n    ...> |> Circle.to_polygon(3)\n    ...> |> to_string\n    \"@@@@@@@@@@@\\n\"  \n    \"@  @@@@@@@@\\n\"  \n    \"@ @  @@@@@@\\n\"  \n    \"@ @@@  @@@@\\n\"  \n    \"@ @@@@@  @@\\n\"  \n    \"@ @@@@@@@ @\\n\"  \n    \"@ @@@@@  @@\\n\"  \n    \"@ @@@  @@@@\\n\"  \n    \"@ @@ @@@@@@\\n\"  \n    \"@   @@@@@@@\\n\"  \n    \"@ @@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@\\n\"","ref":"Vivid.Circle.html#to_polygon/2-examples"},{"type":"type","title":"Vivid.Circle.t/0","doc":"","ref":"Vivid.Circle.html#t:t/0"},{"type":"module","title":"Vivid.Font","doc":"This module takes characters generated by the Hershey module and converts them\ninto groups of shapes using the character's specified left and right padding.\n\nSpecifically this module only knows about the `rowmans` Hershey font, because\nit's all I needed. We need a real font layout system. PR's gratefully accepted.","ref":"Vivid.Font.html"},{"type":"function","title":"Vivid.Font.line/2","doc":"Convert a String containing one or more characters into a shape.\n\nCan only handle characters defined in the `rowmans` Hershey font. Carriage\nreturns and line feeds are also not supported.\n\nThe second argument is a scale factor. Defaults to `1.0`.","ref":"Vivid.Font.html#line/2"},{"type":"function","title":"Example - Vivid.Font.line/2","doc":"iex> use Vivid\n    ...> Font.line(\"hello world\", 0.75)\n    ...> |> to_string\n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@ @@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ @@@@@@@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@ @@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ @@@@@@@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@ @@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ @@@@@@@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@ @@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ @@@@@@@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@ @@@@@ @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ @@@@@@@@@@@@@@ @\\n\"  \n    \"@ @@@    @@@@@@@@@@    @@@@@@@ @@@@@ @@@@@@@@    @@@@@@@@@@@@@@@@@@@ @@@@@ @@@@@ @@@@@@@    @@@@@@@@ @@    @@@ @@@@@@@@    @@ @\\n\"  \n    \"@ @@ @@@@ @@@@@@@  @@@@ @@@@@@ @@@@@ @@@@@@  @@@@  @@@@@@@@@@@@@@@@@ @@@@@ @@@@@ @@@@@  @@@@  @@@@@@ @ @@@@@@@ @@@@@@  @@@@   @\\n\"  \n    \"@   @@@@@@ @@@@@ @@@@@@@ @@@@@ @@@@@ @@@@@ @@@@@@@@ @@@@@@@@@@@@@@@@@ @@@ @ @@@ @@@@@ @@@@@@@@ @@@@@  @@@@@@@@ @@@@@ @@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@ @@@@@ @@@@@@@@ @@@@ @@@@@ @@@@@ @@@@@@@@ @@@@@@@@@@@@@@@@@ @@@ @ @@@ @@@@@ @@@@@@@@ @@@@@  @@@@@@@@ @@@@@ @@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@ @@@@@ @@@@@@@@ @@@@ @@@@@ @@@@@ @@@@@@@@ @@@@@@@@@@@@@@@@@ @@@ @ @@@ @@@@@ @@@@@@@@ @@@@@ @@@@@@@@@ @@@@@ @@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@ @@@@@          @@@@ @@@@@ @@@@@ @@@@@@@@ @@@@@@@@@@@@@@@@@ @@@ @ @@@ @@@@@ @@@@@@@@ @@@@@ @@@@@@@@@ @@@@@ @@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@ @@@@@ @@@@@@@@@@@@@ @@@@@ @@@@@ @@@@@@@@ @@@@@@@@@@@@@@@@@@ @ @@@ @ @@@@@@ @@@@@@@@ @@@@@ @@@@@@@@@ @@@@@ @@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@ @@@@@ @@@@@@@@@@@@@ @@@@@ @@@@@ @@@@@@@@ @@@@@@@@@@@@@@@@@@ @ @@@ @ @@@@@@ @@@@@@@@ @@@@@ @@@@@@@@@ @@@@@ @@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@ @@@@@ @@@@@@@@ @@@@ @@@@@ @@@@@ @@@@@@@@ @@@@@@@@@@@@@@@@@@ @ @@@ @ @@@@@@ @@@@@@@@ @@@@@ @@@@@@@@@ @@@@@ @@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@ @@@@@@ @@@@@@ @@@@@ @@@@@ @@@@@@ @@@@@@ @@@@@@@@@@@@@@@@@@@ @ @@@ @ @@@@@@@ @@@@@@ @@@@@@ @@@@@@@@@ @@@@@@ @@@@@@  @\\n\"  \n    \"@ @@@@@@@@ @@@@@@@ @@@@ @@@@@@ @@@@@ @@@@@@@ @@@@ @@@@@@@@@@@@@@@@@@@@@ @@@@@ @@@@@@@@@ @@@@ @@@@@@@ @@@@@@@@@ @@@@@@@ @@@@ @ @\\n\"  \n    \"@ @@@@@@@@ @@@@@@@@    @@@@@@@ @@@@@ @@@@@@@@    @@@@@@@@@@@@@@@@@@@@@@ @@@@@ @@@@@@@@@@    @@@@@@@@ @@@@@@@@@ @@@@@@@@    @@ @\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"","ref":"Vivid.Font.html#line/2-example"},{"type":"function","title":"Vivid.Font.rowmans/0","doc":"Convert the `rowmans` font into a map with the codepoints (characters) as the\nindex, and the font character as the value.","ref":"Vivid.Font.html#rowmans/0"},{"type":"module","title":"Vivid.Font.Char","doc":"Describes an individual character defined by a Hershey font file.","ref":"Vivid.Font.Char.html"},{"type":"function","title":"Vivid.Font.Char.left_pad/2","doc":"Returns the left padding specified for this character.","ref":"Vivid.Font.Char.html#left_pad/2"},{"type":"function","title":"Vivid.Font.Char.rendered_height/2","doc":"Rendered height of a character.","ref":"Vivid.Font.Char.html#rendered_height/2"},{"type":"function","title":"Vivid.Font.Char.rendered_width/2","doc":"Rendered width of a character.","ref":"Vivid.Font.Char.html#rendered_width/2"},{"type":"function","title":"Vivid.Font.Char.right_pad/2","doc":"Returns the right padding specified for this character.","ref":"Vivid.Font.Char.html#right_pad/2"},{"type":"function","title":"Vivid.Font.Char.to_shape/3","doc":"Convert a %Char{} into a shape which can be rendered.\n\n* `char` is a `%Char{}` struct.\n* `center` the center `%Point{}` around which to render the character.\n* `scale` how much to scale the character by.","ref":"Vivid.Font.Char.html#to_shape/3"},{"type":"function","title":"Vivid.Font.Char.width/2","doc":"Returns the (documented) width of a specific character.\nThis is not the maximum width of the character, as some go beyond or don't reach their documented bounds.\nI assume this is for kerning. I may be wrong.","ref":"Vivid.Font.Char.html#width/2"},{"type":"type","title":"Vivid.Font.Char.t/0","doc":"","ref":"Vivid.Font.Char.html#t:t/0"},{"type":"module","title":"Vivid.Frame","doc":"Frame represents a collection of colours and shapes.\n\nFrame implements both the `Enumerable` and `Collectable` protocols.","ref":"Vivid.Frame.html"},{"type":"module","title":"Examples - Vivid.Frame","doc":"iex> use Vivid\n      ...> Enum.map(1..5, fn i ->\n      ...>   line = Line.init(Point.init(1,1), Point.init(20, i * 4))\n      ...>   {line, RGBA.black}\n      ...> end)\n      ...> |> Enum.into(Frame.init(24, 21, RGBA.white))\n      ...> |> to_string\n      \"@@@@@@@@@@@@@@@@@@@@ @@@\\n\"  \n      \"@@@@@@@@@@@@@@@@@@@ @@@@\\n\"  \n      \"@@@@@@@@@@@@@@@@@@ @@@@@\\n\"  \n      \"@@@@@@@@@@@@@@@@@ @@@@@@\\n\"  \n      \"@@@@@@@@@@@@@@@@ @@@ @@@\\n\"  \n      \"@@@@@@@@@@@@@@@ @@@ @@@@\\n\"  \n      \"@@@@@@@@@@@@@@ @@  @@@@@\\n\"  \n      \"@@@@@@@@@@@@@ @@ @@@@@@@\\n\"  \n      \"@@@@@@@@@@@@ @@ @@@@ @@@\\n\"  \n      \"@@@@@@@@@@@ @@ @@@  @@@@\\n\"  \n      \"@@@@@@@@@@ @  @@  @@@@@@\\n\"  \n      \"@@@@@@@@@ @ @@  @@@@@@@@\\n\"  \n      \"@@@@@@@@ @ @@ @@@@@  @@@\\n\"  \n      \"@@@@@@@   @  @@@   @@@@@\\n\"  \n      \"@@@@@@  @  @@@  @@@@@@@@\\n\"  \n      \"@@@@@  @ @@   @@@@@@@@@@\\n\"  \n      \"@@@@       @@@@@@    @@@\\n\"  \n      \"@@@     @@@      @@@@@@@\\n\"  \n      \"@@         @@@@@@@@@@@@@\\n\"  \n      \"@    @@@@@@@@@@@@@@@@@@@\\n\"  \n      \"@@@@@@@@@@@@@@@@@@@@@@@@\\n\"","ref":"Vivid.Frame.html#module-examples"},{"type":"function","title":"Vivid.Frame.background_colour/1","doc":"Return the background colour of the `frame`.","ref":"Vivid.Frame.html#background_colour/1"},{"type":"function","title":"Example - Vivid.Frame.background_colour/1","doc":"iex> Vivid.Frame.init(80, 25) |> Vivid.Frame.background_colour\n    Vivid.RGBA.init(0, 0, 0, 0)","ref":"Vivid.Frame.html#background_colour/1-example"},{"type":"function","title":"Vivid.Frame.background_colour/2","doc":"Change the background `colour` of the `frame`.","ref":"Vivid.Frame.html#background_colour/2"},{"type":"function","title":"Example - Vivid.Frame.background_colour/2","doc":"iex> Vivid.Frame.init(80,25)\n    ...> |> Vivid.Frame.background_colour(Vivid.RGBA.white)\n    ...> |> Vivid.Frame.background_colour\n    Vivid.RGBA.init(1, 1, 1, 1)","ref":"Vivid.Frame.html#background_colour/2-example"},{"type":"function","title":"Vivid.Frame.buffer/1","doc":"Render a `frame` into a buffer for display horizontally.\n\nReturns a one-dimensional List of `RGBA` colours with alpha-compositing\ncompleted.","ref":"Vivid.Frame.html#buffer/1"},{"type":"function","title":"Vivid.Frame.buffer/2","doc":"Render a `frame` into a buffer for display.\n\nYou can specify either `:horizontal` or `:vertical` mode, where in\n`:horizontal` mode the buffer is rendered row-by-row then column-by-column\nand in `:vertical` mode the buffer is rendered column-by-column then\nrow-by-row.\n\nReturns a one-dimensional List of `RGBA` colours with alpha-compositing\ncompleted.","ref":"Vivid.Frame.html#buffer/2"},{"type":"function","title":"Vivid.Frame.clear/1","doc":"Clear the `frame` of any shapes.","ref":"Vivid.Frame.html#clear/1"},{"type":"function","title":"Vivid.Frame.height/1","doc":"Return the height of the `frame`.","ref":"Vivid.Frame.html#height/1"},{"type":"function","title":"Example - Vivid.Frame.height/1","doc":"iex> Vivid.Frame.init(80, 25) |> Vivid.Frame.height\n    25","ref":"Vivid.Frame.html#height/1-example"},{"type":"function","title":"Vivid.Frame.init/3","doc":"Initialize a frame buffer.\n\n* `width` the width of the frame, in pixels.\n* `height` the height of the frame, in pixels.\n* `colour` the default colour of the frame.","ref":"Vivid.Frame.html#init/3"},{"type":"function","title":"Example - Vivid.Frame.init/3","doc":"iex> Vivid.Frame.init(4, 4)\n    Vivid.Frame.init(4, 4, Vivid.RGBA.init(0, 0, 0, 0))","ref":"Vivid.Frame.html#init/3-example"},{"type":"function","title":"Vivid.Frame.push/3","doc":"Add a shape to the frame buffer.\n\n* `frame` is the frame to modify.\n* `shape` is the shape to add.\n* `colour` is the colour of the shape being added.","ref":"Vivid.Frame.html#push/3"},{"type":"function","title":"Examples - Vivid.Frame.push/3","doc":"iex> Vivid.Frame.init(5,5)\n    ...> |> Vivid.Frame.push(Vivid.Line.init(Vivid.Point.init(1,1), Vivid.Point.init(3,3)), Vivid.RGBA.white)\n    ...> |> to_string\n    \"     \\n\"  \n    \"   @ \\n\"  \n    \"  @  \\n\"  \n    \" @   \\n\"  \n    \"     \\n\"\n\n    iex> Vivid.Frame.init(5,5)\n    ...> |> Vivid.Frame.push(\n    ...>      Vivid.Path.init([\n    ...>        Vivid.Point.init(1,1),\n    ...>        Vivid.Point.init(1,3),\n    ...>        Vivid.Point.init(3,3),\n    ...>        Vivid.Point.init(3,1),\n    ...>      ]), Vivid.RGBA.white\n    ...>    )\n    ...> |> to_string\n    \"     \\n\"  \n    \" @@@ \\n\"  \n    \" @ @ \\n\"  \n    \" @ @ \\n\"  \n    \"     \\n\"\n\n    iex> Vivid.Frame.init(5,5)\n    ...> |> Vivid.Frame.push(\n    ...>      Vivid.Polygon.init([\n    ...>        Vivid.Point.init(1,1),\n    ...>        Vivid.Point.init(1,3),\n    ...>        Vivid.Point.init(3,3),\n    ...>        Vivid.Point.init(3,1),\n    ...>      ]), Vivid.RGBA.white\n    ...>    )\n    ...> |> to_string\n    \"     \\n\"  \n    \" @@@ \\n\"  \n    \" @ @ \\n\"  \n    \" @@@ \\n\"  \n    \"     \\n\"\n\n    iex> circle = Vivid.Circle.init(Vivid.Point.init(5,5), 4)\n    ...> Vivid.Frame.init(11, 10)\n    ...> |> Vivid.Frame.push(circle, Vivid.RGBA.white)\n    ...> |> to_string\n    \"    @@@    \\n\"  \n    \"  @@   @@  \\n\"  \n    \"  @     @  \\n\"  \n    \" @       @ \\n\"  \n    \" @       @ \\n\"  \n    \" @       @ \\n\"  \n    \"  @     @  \\n\"  \n    \"  @@   @@  \\n\"  \n    \"    @@@    \\n\"  \n    \"           \\n\"\n\n    iex> line = Vivid.Line.init(Vivid.Point.init(0,0), Vivid.Point.init(50,50))\n    ...> Vivid.Frame.init(5,5)\n    ...> |> Vivid.Frame.push(line, Vivid.RGBA.white)\n    ...> |> to_string\n    \"    @\\n\"  \n    \"   @ \\n\"  \n    \"  @  \\n\"  \n    \" @   \\n\"  \n    \"@    \\n\"","ref":"Vivid.Frame.html#push/3-examples"},{"type":"function","title":"Vivid.Frame.width/1","doc":"Return the width of the `frame`.","ref":"Vivid.Frame.html#width/1"},{"type":"function","title":"Example - Vivid.Frame.width/1","doc":"iex> Vivid.Frame.init(80, 25) |> Vivid.Frame.width\n    80","ref":"Vivid.Frame.html#width/1-example"},{"type":"type","title":"Vivid.Frame.t/0","doc":"","ref":"Vivid.Frame.html#t:t/0"},{"type":"module","title":"Vivid.Group","doc":"Represents a collection of shapes which can be Rasterized in a single pass.\n\nGroup implements both the `Enumerable` and `Collectable` protocols.","ref":"Vivid.Group.html"},{"type":"module","title":"Example - Vivid.Group","doc":"iex> use Vivid\n  ...> circle = Circle.init(Point.init(10, 10), 10)\n  ...> line   = Line.init(Point.init(0,0), Point.init(20,20))\n  ...> Group.init([circle, line])\n  ...> |> to_string()\n  \"@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n  \"@@@@@@@@       @@@@@@ @\\n\"  \n  \"@@@@@@  @@@@@@@  @@@ @@\\n\"  \n  \"@@@@@ @@@@@@@@@@@ @ @@@\\n\"  \n  \"@@@@ @@@@@@@@@@@@@ @@@@\\n\"  \n  \"@@@ @@@@@@@@@@@@@ @ @@@\\n\"  \n  \"@@ @@@@@@@@@@@@@ @@@ @@\\n\"  \n  \"@@ @@@@@@@@@@@@ @@@@ @@\\n\"  \n  \"@ @@@@@@@@@@@@ @@@@@@ @\\n\"  \n  \"@ @@@@@@@@@@@ @@@@@@@ @\\n\"  \n  \"@ @@@@@@@@@@ @@@@@@@@ @\\n\"  \n  \"@ @@@@@@@@@ @@@@@@@@@ @\\n\"  \n  \"@ @@@@@@@@ @@@@@@@@@@ @\\n\"  \n  \"@ @@@@@@@ @@@@@@@@@@@ @\\n\"  \n  \"@ @@@@@@ @@@@@@@@@@@@ @\\n\"  \n  \"@@ @@@@ @@@@@@@@@@@@ @@\\n\"  \n  \"@@ @@@ @@@@@@@@@@@@@ @@\\n\"  \n  \"@@@ @ @@@@@@@@@@@@@ @@@\\n\"  \n  \"@@@@ @@@@@@@@@@@@@ @@@@\\n\"  \n  \"@@@ @ @@@@@@@@@@@ @@@@@\\n\"  \n  \"@@ @@@  @@@@@@@  @@@@@@\\n\"  \n  \"@ @@@@@@       @@@@@@@@\\n\"  \n  \"@@@@@@@@@@@@@@@@@@@@@@@\\n\"","ref":"Vivid.Group.html#module-example"},{"type":"function","title":"Vivid.Group.delete/2","doc":"Remove a shape from a Group","ref":"Vivid.Group.html#delete/2"},{"type":"function","title":"Example - Vivid.Group.delete/2","doc":"iex> line = Vivid.Line.init(Vivid.Point.init(1,1), Vivid.Point.init(10,10))\n    ...> Vivid.Group.init([line])\n    ...> |> Vivid.Group.delete(line)\n    %Vivid.Group{shapes: MapSet.new()}","ref":"Vivid.Group.html#delete/2-example"},{"type":"function","title":"Vivid.Group.init/0","doc":"Initialize an empty group.","ref":"Vivid.Group.html#init/0"},{"type":"function","title":"Examples - Vivid.Group.init/0","doc":"iex> Vivid.Group.init\n    %Vivid.Group{shapes: MapSet.new([])}","ref":"Vivid.Group.html#init/0-examples"},{"type":"function","title":"Vivid.Group.init/1","doc":"Initialize a group from a list of shapes.","ref":"Vivid.Group.html#init/1"},{"type":"function","title":"Example - Vivid.Group.init/1","doc":"iex> circle = Vivid.Circle.init(Vivid.Point.init(5,5), 5)\n    ...> line   = Vivid.Line.init(Vivid.Point.init(1,1), Vivid.Point.init(10,10))\n    ...> Vivid.Group.init([circle, line])\n    Vivid.Group.init([Vivid.Line.init(Vivid.Point.init(1, 1), Vivid.Point.init(10, 10)), Vivid.Circle.init(Vivid.Point.init(5, 5), 5)])","ref":"Vivid.Group.html#init/1-example"},{"type":"function","title":"Vivid.Group.put/2","doc":"Add a shape to a Group","ref":"Vivid.Group.html#put/2"},{"type":"function","title":"Example - Vivid.Group.put/2","doc":"iex> line = Vivid.Line.init(Vivid.Point.init(1,1), Vivid.Point.init(10,10))\n    ...> Vivid.Group.init()\n    ...> |> Vivid.Group.put(line)\n    %Vivid.Group{shapes: MapSet.new([\n      %Vivid.Line{origin: %Vivid.Point{x: 1, y: 1}, termination: %Vivid.Point{x: 10, y: 10}}\n    ])}","ref":"Vivid.Group.html#put/2-example"},{"type":"type","title":"Vivid.Group.t/0","doc":"","ref":"Vivid.Group.html#t:t/0"},{"type":"module","title":"Vivid.Hershey","doc":"Supports reading the Hershey Vector Font format and converting them into paths.","ref":"Vivid.Hershey.html"},{"type":"function","title":"Vivid.Hershey.definitions/1","doc":"Returns a map of \"character IDs\" to %Char{} structs, which can\nbe passed to `char_to_shape` to turn into renderable shapes.","ref":"Vivid.Hershey.html#definitions/1"},{"type":"module","title":"Vivid.Line","doc":"Represents a line segment between two Points in 2D space.","ref":"Vivid.Line.html"},{"type":"module","title":"Example - Vivid.Line","doc":"iex> use Vivid\n  ...> Line.init(Point.init(0,0), Point.init(5,5))\n  ...> |> to_string()\n  \"@@@@@@@@\\n\"  \n  \"@@@@@@ @\\n\"  \n  \"@@@@@ @@\\n\"  \n  \"@@@@ @@@\\n\"  \n  \"@@@ @@@@\\n\"  \n  \"@@ @@@@@\\n\"  \n  \"@ @@@@@@\\n\"  \n  \"@@@@@@@@\\n\"","ref":"Vivid.Line.html#module-example"},{"type":"function","title":"Vivid.Line.height/1","doc":"Calculates the absolute Y (vertical) distance between the origin and termination points.","ref":"Vivid.Line.html#height/1"},{"type":"function","title":"Example - Vivid.Line.height/1","doc":"iex> Vivid.Line.init(Vivid.Point.init(1,1), Vivid.Point.init(4,14)) |> Vivid.Line.height\n    13","ref":"Vivid.Line.html#height/1-example"},{"type":"function","title":"Vivid.Line.horizontal?/1","doc":"Returns true if a line is horizontal.","ref":"Vivid.Line.html#horizontal?/1"},{"type":"function","title":"Example - Vivid.Line.horizontal?/1","doc":"iex> use Vivid\n    ...> Line.init(Point.init(10,10), Point.init(20,10))\n    ...> |> Line.horizontal?\n    true\n\n    iex> use Vivid\n    ...> Line.init(Point.init(10,10), Point.init(20,11))\n    ...> |> Line.horizontal?\n    false","ref":"Vivid.Line.html#horizontal?/1-example"},{"type":"function","title":"Vivid.Line.init/1","doc":"Create a `Line` from a two-element list of points.","ref":"Vivid.Line.html#init/1"},{"type":"function","title":"Vivid.Line.init/2","doc":"Create a Line given an `origin` and `termination` point.","ref":"Vivid.Line.html#init/2"},{"type":"function","title":"Examples - Vivid.Line.init/2","doc":"iex> Vivid.Line.init(Vivid.Point.init(1,1), Vivid.Point.init(4,4))\n    %Vivid.Line{origin: %Vivid.Point{x: 1, y: 1}, termination: %Vivid.Point{x: 4, y: 4}}","ref":"Vivid.Line.html#init/2-examples"},{"type":"function","title":"Vivid.Line.length/1","doc":"Calculates straight-line distance between the two ends of the line segment using\nPythagoras' Theorem","ref":"Vivid.Line.html#length/1"},{"type":"function","title":"Example - Vivid.Line.length/1","doc":"iex> Vivid.Line.init(Vivid.Point.init(1,1), Vivid.Point.init(4,5)) |> Vivid.Line.length\n    5.0","ref":"Vivid.Line.html#length/1-example"},{"type":"function","title":"Vivid.Line.on?/2","doc":"Returns whether a point is on the line.","ref":"Vivid.Line.html#on?/2"},{"type":"function","title":"Example - Vivid.Line.on?/2","doc":"iex> use Vivid\n  ...> Line.init(Point.init(1,1), Point.init(3,1))\n  ...> |> Line.on?(Point.init(2,1))\n  true\n\n  iex> use Vivid\n  ...> Line.init(Point.init(1,1), Point.init(3,1))\n  ...> |> Line.on?(Point.init(2,2))\n  false","ref":"Vivid.Line.html#on?/2-example"},{"type":"function","title":"Vivid.Line.origin/1","doc":"Returns the origin (starting) point of the line segment.","ref":"Vivid.Line.html#origin/1"},{"type":"function","title":"Example - Vivid.Line.origin/1","doc":"iex> Vivid.Line.init(Vivid.Point.init(1,1), Vivid.Point.init(4,4)) |> Vivid.Line.origin\n    %Vivid.Point{x: 1, y: 1}","ref":"Vivid.Line.html#origin/1-example"},{"type":"function","title":"Vivid.Line.termination/1","doc":"Returns the termination (ending) point of the line segment.","ref":"Vivid.Line.html#termination/1"},{"type":"function","title":"Example - Vivid.Line.termination/1","doc":"iex> use Vivid\n    ...> Line.init(Point.init(1,1), Point.init(4,4))\n    ...> |> Line.termination\n    Vivid.Point.init(4, 4)","ref":"Vivid.Line.html#termination/1-example"},{"type":"function","title":"Vivid.Line.vertical?/1","doc":"Returns true if a line is vertical.","ref":"Vivid.Line.html#vertical?/1"},{"type":"function","title":"Example - Vivid.Line.vertical?/1","doc":"iex> use Vivid\n    ...> Line.init(Point.init(10,10), Point.init(10,20))\n    ...> |> Line.vertical?\n    true\n\n    iex> use Vivid\n    ...> Line.init(Point.init(10,10), Point.init(11,20))\n    ...> |> Line.vertical?\n    false","ref":"Vivid.Line.html#vertical?/1-example"},{"type":"function","title":"Vivid.Line.width/1","doc":"Calculates the absolute X (horizontal) distance between the origin and termination points.","ref":"Vivid.Line.html#width/1"},{"type":"function","title":"Example - Vivid.Line.width/1","doc":"iex> Vivid.Line.init(Vivid.Point.init(1,1), Vivid.Point.init(14,4)) |> Vivid.Line.width\n    13","ref":"Vivid.Line.html#width/1-example"},{"type":"function","title":"Vivid.Line.x_distance/1","doc":"Calculates the X (horizontal) distance between the origin and termination points.","ref":"Vivid.Line.html#x_distance/1"},{"type":"function","title":"Example - Vivid.Line.x_distance/1","doc":"iex> Vivid.Line.init(Vivid.Point.init(14,1), Vivid.Point.init(1,4)) |> Vivid.Line.x_distance\n    -13","ref":"Vivid.Line.html#x_distance/1-example"},{"type":"function","title":"Vivid.Line.x_intersect/2","doc":"Find the point on the line where it intersects with the specified `x` axis.","ref":"Vivid.Line.html#x_intersect/2"},{"type":"function","title":"Example - Vivid.Line.x_intersect/2","doc":"iex> use Vivid\n    ...> Line.init(Point.init(25, 15), Point.init(5, 2))\n    ...> |> Line.x_intersect(10)\n    Vivid.Point.init(10, 5.25)","ref":"Vivid.Line.html#x_intersect/2-example"},{"type":"function","title":"Vivid.Line.y_distance/1","doc":"Calculates the Y (vertical) distance between the origin and termination points.","ref":"Vivid.Line.html#y_distance/1"},{"type":"function","title":"Example - Vivid.Line.y_distance/1","doc":"iex> Vivid.Line.init(Vivid.Point.init(1,14), Vivid.Point.init(4,1)) |> Vivid.Line.y_distance\n    -13","ref":"Vivid.Line.html#y_distance/1-example"},{"type":"function","title":"Vivid.Line.y_intersect/2","doc":"Find the point on the line where it intersects with the specified `y` axis.","ref":"Vivid.Line.html#y_intersect/2"},{"type":"function","title":"Example - Vivid.Line.y_intersect/2","doc":"iex> use Vivid\n    ...> Line.init(Point.init(25, 15), Point.init(5, 2))\n    ...> |> Line.y_intersect(10)\n    Vivid.Point.init(17.307692307692307, 10)","ref":"Vivid.Line.html#y_intersect/2-example"},{"type":"type","title":"Vivid.Line.t/0","doc":"","ref":"Vivid.Line.html#t:t/0"},{"type":"module","title":"Vivid.Math","doc":"I made this because I was constantly importing a small selection of\nErlang's `:math` module, and then manually implementing\n`degrees_to_radians/1` which got pretty annoying after a while.","ref":"Vivid.Math.html"},{"type":"function","title":"Vivid.Math.cos/1","doc":"Delegates to `:math.cos/1`.","ref":"Vivid.Math.html#cos/1"},{"type":"function","title":"Vivid.Math.degrees_to_radians/1","doc":"Convert degrees into radians.","ref":"Vivid.Math.html#degrees_to_radians/1"},{"type":"function","title":"Examples: - Vivid.Math.degrees_to_radians/1","doc":"iex> 180 |> Vivid.Math.degrees_to_radians\n    :math.pi","ref":"Vivid.Math.html#degrees_to_radians/1-examples"},{"type":"function","title":"Vivid.Math.pi/0","doc":"Delegates to `:math.pi/0`.","ref":"Vivid.Math.html#pi/0"},{"type":"function","title":"Vivid.Math.pow/2","doc":"Delegates to `:math.pow/2`.","ref":"Vivid.Math.html#pow/2"},{"type":"function","title":"Vivid.Math.sin/1","doc":"Delegates to `:math.sin/1`.","ref":"Vivid.Math.html#sin/1"},{"type":"function","title":"Vivid.Math.sqrt/1","doc":"Delegates to `:math.sqrt/1`.","ref":"Vivid.Math.html#sqrt/1"},{"type":"module","title":"Vivid.Path","doc":"Describes a path as a series of vertices.\n\nPath implements both the `Enumerable` and `Collectable` protocols.","ref":"Vivid.Path.html"},{"type":"module","title":"Example - Vivid.Path","doc":"iex> use Vivid\n    ...> 0..3\n    ...> |> Stream.map(fn\n    ...> i when rem(i, 2) == 0 -> Point.init(i * 3, i * 4)\n    ...> i -> Point.init(i * 3, i * 2)\n    ...> end)\n    ...> |> Enum.into(Path.init())\n    ...> |> to_string()\n    \"@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@ @@@@\\n\"  \n    \"@@@@@@@   @@\\n\"  \n    \"@@@@@@ @@@ @\\n\"  \n    \"@@@@@@ @@@@@\\n\"  \n    \"@@@@@ @@@@@@\\n\"  \n    \"@@@@@ @@@@@@\\n\"  \n    \"@@@@ @@@@@@@\\n\"  \n    \"@@  @@@@@@@@\\n\"  \n    \"@ @@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@\\n\"","ref":"Vivid.Path.html#module-example"},{"type":"function","title":"Vivid.Path.delete/2","doc":"Remove a vertex from a Path.","ref":"Vivid.Path.html#delete/2"},{"type":"function","title":"Example - Vivid.Path.delete/2","doc":"iex> Vivid.Path.init([Vivid.Point.init(1,1), Vivid.Point.init(2,2)]) |> Vivid.Path.delete(Vivid.Point.init(2,2))\n    %Vivid.Path{vertices: [%Vivid.Point{x: 1, y: 1}]}","ref":"Vivid.Path.html#delete/2-example"},{"type":"function","title":"Vivid.Path.delete_at/2","doc":"Remove a vertex at a specific index in the Path.","ref":"Vivid.Path.html#delete_at/2"},{"type":"function","title":"Example - Vivid.Path.delete_at/2","doc":"iex> Vivid.Path.init([Vivid.Point.init(1,1), Vivid.Point.init(2,2)]) |> Vivid.Path.delete_at(1)\n    %Vivid.Path{vertices: [%Vivid.Point{x: 1, y: 1}]}","ref":"Vivid.Path.html#delete_at/2-example"},{"type":"function","title":"Vivid.Path.first/1","doc":"Return the first vertex in the Path.","ref":"Vivid.Path.html#first/1"},{"type":"function","title":"Example - Vivid.Path.first/1","doc":"iex> Vivid.Path.init([Vivid.Point.init(1,1), Vivid.Point.init(2,2)]) |> Vivid.Path.first\n    %Vivid.Point{x: 1, y: 1}","ref":"Vivid.Path.html#first/1-example"},{"type":"function","title":"Vivid.Path.init/0","doc":"Initialize an empty path.","ref":"Vivid.Path.html#init/0"},{"type":"function","title":"Example - Vivid.Path.init/0","doc":"iex> Vivid.Path.init\n    %Vivid.Path{vertices: []}","ref":"Vivid.Path.html#init/0-example"},{"type":"function","title":"Vivid.Path.init/1","doc":"Initialize a path from a list of points.","ref":"Vivid.Path.html#init/1"},{"type":"function","title":"Example - Vivid.Path.init/1","doc":"iex> Vivid.Path.init([Vivid.Point.init(1,1), Vivid.Point.init(1,2), Vivid.Point.init(2,2), Vivid.Point.init(2,1)])\n    %Vivid.Path{vertices: [\n      %Vivid.Point{x: 1, y: 1},\n      %Vivid.Point{x: 1, y: 2},\n      %Vivid.Point{x: 2, y: 2},\n      %Vivid.Point{x: 2, y: 1}\n    ]}","ref":"Vivid.Path.html#init/1-example"},{"type":"function","title":"Vivid.Path.insert_at/3","doc":"Insert a vertex at a specific index in the Path.","ref":"Vivid.Path.html#insert_at/3"},{"type":"function","title":"Example - Vivid.Path.insert_at/3","doc":"iex> Vivid.Path.init([Vivid.Point.init(1,1), Vivid.Point.init(2,2)]) |> Vivid.Path.insert_at(1, Vivid.Point.init(3,3))\n    %Vivid.Path{vertices: [\n      %Vivid.Point{x: 1, y: 1},\n      %Vivid.Point{x: 3, y: 3},\n      %Vivid.Point{x: 2, y: 2}\n    ]}","ref":"Vivid.Path.html#insert_at/3-example"},{"type":"function","title":"Vivid.Path.last/1","doc":"Return the last vertex in the Path.","ref":"Vivid.Path.html#last/1"},{"type":"function","title":"Example - Vivid.Path.last/1","doc":"iex> Vivid.Path.init([Vivid.Point.init(1,1), Vivid.Point.init(2,2)]) |> Vivid.Path.last\n    %Vivid.Point{x: 2, y: 2}","ref":"Vivid.Path.html#last/1-example"},{"type":"function","title":"Vivid.Path.replace_at/3","doc":"Replace a vertex at a specific index in the Path.","ref":"Vivid.Path.html#replace_at/3"},{"type":"function","title":"Example - Vivid.Path.replace_at/3","doc":"iex> Vivid.Path.init([Vivid.Point.init(1,1), Vivid.Point.init(2,2), Vivid.Point.init(3,3)]) |> Vivid.Path.replace_at(1, Vivid.Point.init(4,4))\n    %Vivid.Path{vertices: [\n      %Vivid.Point{x: 1, y: 1},\n      %Vivid.Point{x: 4, y: 4},\n      %Vivid.Point{x: 3, y: 3}\n    ]}","ref":"Vivid.Path.html#replace_at/3-example"},{"type":"function","title":"Vivid.Path.to_lines/1","doc":"Convert a path into a list of lines joined by the vertices.","ref":"Vivid.Path.html#to_lines/1"},{"type":"function","title":"Examples - Vivid.Path.to_lines/1","doc":"iex> Vivid.Path.init([Vivid.Point.init(1,1), Vivid.Point.init(1,2), Vivid.Point.init(2,2), Vivid.Point.init(2,1)]) |> Vivid.Path.to_lines\n    [%Vivid.Line{origin: %Vivid.Point{x: 1, y: 1},\n       termination: %Vivid.Point{x: 1, y: 2}},\n     %Vivid.Line{origin: %Vivid.Point{x: 1, y: 2},\n       termination: %Vivid.Point{x: 2, y: 2}},\n     %Vivid.Line{origin: %Vivid.Point{x: 2, y: 2},\n       termination: %Vivid.Point{x: 2, y: 1}}]","ref":"Vivid.Path.html#to_lines/1-examples"},{"type":"type","title":"Vivid.Path.t/0","doc":"","ref":"Vivid.Path.html#t:t/0"},{"type":"module","title":"Vivid.Point","doc":"Represents an individual point in (2D) space.","ref":"Vivid.Point.html"},{"type":"module","title":"Example - Vivid.Point","doc":"iex> use Vivid\n  ...> point = Point.init(2,2)\n  ...> Frame.init(5,5, RGBA.white())\n  ...> |> Frame.push(point, RGBA.black())\n  ...> |> to_string()\n  \"@@@@@\\n\"  \n  \"@@@@@\\n\"  \n  \"@@ @@\\n\"  \n  \"@@@@@\\n\"  \n  \"@@@@@\\n\"","ref":"Vivid.Point.html#module-example"},{"type":"function","title":"Vivid.Point.init/2","doc":"Creates a Point using `x` and `y` coordinates.","ref":"Vivid.Point.html#init/2"},{"type":"function","title":"Examples - Vivid.Point.init/2","doc":"iex> Vivid.Point.init(13, 27)\n    %Vivid.Point{x: 13, y: 27}","ref":"Vivid.Point.html#init/2-examples"},{"type":"function","title":"Vivid.Point.round/1","doc":"Round the coordinates in the point to the nearest integer value.","ref":"Vivid.Point.html#round/1"},{"type":"function","title":"Example - Vivid.Point.round/1","doc":"iex> Vivid.Point.init(1.23, 4.56)\n    ...> |> Vivid.Point.round\n    Vivid.Point.init(1, 5)","ref":"Vivid.Point.html#round/1-example"},{"type":"function","title":"Vivid.Point.swap_xy/1","doc":"Simple helper to swap X and Y coordinates - used\nwhen translating the frame buffer to vertical.","ref":"Vivid.Point.html#swap_xy/1"},{"type":"function","title":"Example - Vivid.Point.swap_xy/1","doc":"iex> Vivid.Point.init(13, 27)\n    ...> |> Vivid.Point.swap_xy\n    Vivid.Point.init(27, 13)","ref":"Vivid.Point.html#swap_xy/1-example"},{"type":"function","title":"Vivid.Point.vector/2","doc":"Return the vector in x and y between point `a` and point `b`.","ref":"Vivid.Point.html#vector/2"},{"type":"function","title":"Example - Vivid.Point.vector/2","doc":"iex> use Vivid\n    ...> a = Point.init(10, 10)\n    ...> b = Point.init(20, 20)\n    ...> Point.vector(a, b)\n    {10, 10}","ref":"Vivid.Point.html#vector/2-example"},{"type":"function","title":"Vivid.Point.x/1","doc":"Returns the X coordinate of the point.","ref":"Vivid.Point.html#x/1"},{"type":"function","title":"Examples - Vivid.Point.x/1","doc":"iex> Vivid.Point.init(13, 27) |> Vivid.Point.x\n    13","ref":"Vivid.Point.html#x/1-examples"},{"type":"function","title":"Vivid.Point.y/1","doc":"Returns the Y coordinate of the point.","ref":"Vivid.Point.html#y/1"},{"type":"function","title":"Examples - Vivid.Point.y/1","doc":"iex> Vivid.Point.init(13, 27) |> Vivid.Point.y\n    27","ref":"Vivid.Point.html#y/1-examples"},{"type":"type","title":"Vivid.Point.t/0","doc":"","ref":"Vivid.Point.html#t:t/0"},{"type":"module","title":"Vivid.Polygon","doc":"Describes a Polygon as a series of vertices.\n\nPolygon implements both the `Enumerable` and `Collectable` protocols.","ref":"Vivid.Polygon.html"},{"type":"module","title":"Example - Vivid.Polygon","doc":"iex> use Vivid\n    ...> 0..3\n    ...> |> Stream.map(fn\n    ...> i when rem(i, 2) == 0 -> Point.init(i * 3, i * 4)\n    ...> i -> Point.init(i * 3, i * 2)\n    ...> end)\n    ...> |> Enum.into(Polygon.init())\n    ...> |> to_string()\n    \"@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@ @@@@\\n\"  \n    \"@@@@@@@   @@\\n\"  \n    \"@@@@@@ @@@ @\\n\"  \n    \"@@@@@@ @  @@\\n\"  \n    \"@@@@@ @ @@@@\\n\"  \n    \"@@@@@  @@@@@\\n\"  \n    \"@@@@ @@@@@@@\\n\"  \n    \"@@  @@@@@@@@\\n\"  \n    \"@ @@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@\\n\"","ref":"Vivid.Polygon.html#module-example"},{"type":"function","title":"Vivid.Polygon.delete/2","doc":"Remove a vertex from a Polygon.","ref":"Vivid.Polygon.html#delete/2"},{"type":"function","title":"Example - Vivid.Polygon.delete/2","doc":"iex> Vivid.Polygon.init([Vivid.Point.init(1,1), Vivid.Point.init(2,2)]) |> Vivid.Polygon.delete(Vivid.Point.init(2,2))\n    %Vivid.Polygon{vertices: [%Vivid.Point{x: 1, y: 1}]}","ref":"Vivid.Polygon.html#delete/2-example"},{"type":"function","title":"Vivid.Polygon.delete_at/2","doc":"Remove a vertex at a specific index in the Polygon.","ref":"Vivid.Polygon.html#delete_at/2"},{"type":"function","title":"Example - Vivid.Polygon.delete_at/2","doc":"iex> Vivid.Polygon.init([Vivid.Point.init(1,1), Vivid.Point.init(2,2)]) |> Vivid.Polygon.delete_at(1)\n    %Vivid.Polygon{vertices: [%Vivid.Point{x: 1, y: 1}]}","ref":"Vivid.Polygon.html#delete_at/2-example"},{"type":"function","title":"Vivid.Polygon.fill/2","doc":"Turn on or off filling for this polygon.","ref":"Vivid.Polygon.html#fill/2"},{"type":"function","title":"Example - Vivid.Polygon.fill/2","doc":"iex> use Vivid\n    ...> Polygon.init([Point.init(1,1), Point.init(2,2), Point.init(1,2)])\n    ...> |> Polygon.fill(true)\n    ...> |> Polygon.filled?\n    true","ref":"Vivid.Polygon.html#fill/2-example"},{"type":"function","title":"Vivid.Polygon.filled?/1","doc":"Is the polygon filled or not?","ref":"Vivid.Polygon.html#filled?/1"},{"type":"function","title":"Example - Vivid.Polygon.filled?/1","doc":"iex> use Vivid\n    ...> Polygon.init([Point.init(1,1), Point.init(2,2), Point.init(1,2)])\n    ...> |> Polygon.filled?\n    false\n\n    iex> use Vivid\n    ...> Polygon.init([Point.init(1,1), Point.init(2,2), Point.init(1,2)], true)\n    ...> |> Polygon.filled?\n    true\n\n    iex> use Vivid\n    ...> Polygon.init([Point.init(1,1), Point.init(2,2), Point.init(1,2)], false)\n    ...> |> Polygon.filled?\n    false","ref":"Vivid.Polygon.html#filled?/1-example"},{"type":"function","title":"Vivid.Polygon.first/1","doc":"Return the first vertex in the Polygon.","ref":"Vivid.Polygon.html#first/1"},{"type":"function","title":"Example - Vivid.Polygon.first/1","doc":"iex> Vivid.Polygon.init([Vivid.Point.init(1,1), Vivid.Point.init(2,2)]) |> Vivid.Polygon.first\n    %Vivid.Point{x: 1, y: 1}","ref":"Vivid.Polygon.html#first/1-example"},{"type":"function","title":"Vivid.Polygon.init/0","doc":"Initialize an empty Polygon.","ref":"Vivid.Polygon.html#init/0"},{"type":"function","title":"Example - Vivid.Polygon.init/0","doc":"iex> Vivid.Polygon.init\n    %Vivid.Polygon{vertices: []}","ref":"Vivid.Polygon.html#init/0-example"},{"type":"function","title":"Vivid.Polygon.init/1","doc":"Initialize a Polygon from a list of points.","ref":"Vivid.Polygon.html#init/1"},{"type":"function","title":"Example - Vivid.Polygon.init/1","doc":"iex> Vivid.Polygon.init([Vivid.Point.init(1,1), Vivid.Point.init(1,2), Vivid.Point.init(2,2), Vivid.Point.init(2,1)])\n    %Vivid.Polygon{vertices: [\n      %Vivid.Point{x: 1, y: 1},\n      %Vivid.Point{x: 1, y: 2},\n      %Vivid.Point{x: 2, y: 2},\n      %Vivid.Point{x: 2, y: 1}\n    ]}","ref":"Vivid.Polygon.html#init/1-example"},{"type":"function","title":"Vivid.Polygon.insert_at/3","doc":"Insert a vertex at a specific index in the Polygon.","ref":"Vivid.Polygon.html#insert_at/3"},{"type":"function","title":"Example - Vivid.Polygon.insert_at/3","doc":"iex> Vivid.Polygon.init([Vivid.Point.init(1,1), Vivid.Point.init(2,2)]) |> Vivid.Polygon.insert_at(1, Vivid.Point.init(3,3))\n    %Vivid.Polygon{vertices: [\n      %Vivid.Point{x: 1, y: 1},\n      %Vivid.Point{x: 3, y: 3},\n      %Vivid.Point{x: 2, y: 2}\n    ]}","ref":"Vivid.Polygon.html#insert_at/3-example"},{"type":"function","title":"Vivid.Polygon.last/1","doc":"Return the last vertext in the Polygon.","ref":"Vivid.Polygon.html#last/1"},{"type":"function","title":"Example - Vivid.Polygon.last/1","doc":"iex> Vivid.Polygon.init([Vivid.Point.init(1,1), Vivid.Point.init(2,2)]) |> Vivid.Polygon.last\n    %Vivid.Point{x: 2, y: 2}","ref":"Vivid.Polygon.html#last/1-example"},{"type":"function","title":"Vivid.Polygon.replace_at/3","doc":"Replace a vertex at a specific index in the Polygon.","ref":"Vivid.Polygon.html#replace_at/3"},{"type":"function","title":"Example - Vivid.Polygon.replace_at/3","doc":"iex> Vivid.Polygon.init([Vivid.Point.init(1,1), Vivid.Point.init(2,2), Vivid.Point.init(3,3)]) |> Vivid.Polygon.replace_at(1, Vivid.Point.init(4,4))\n    %Vivid.Polygon{vertices: [\n      %Vivid.Point{x: 1, y: 1},\n      %Vivid.Point{x: 4, y: 4},\n      %Vivid.Point{x: 3, y: 3}\n    ]}","ref":"Vivid.Polygon.html#replace_at/3-example"},{"type":"function","title":"Vivid.Polygon.to_lines/1","doc":"Convert a Polygon into a list of lines joined by the vertices.","ref":"Vivid.Polygon.html#to_lines/1"},{"type":"function","title":"Examples - Vivid.Polygon.to_lines/1","doc":"iex> Vivid.Polygon.init([Vivid.Point.init(1,1), Vivid.Point.init(1,2), Vivid.Point.init(2,2), Vivid.Point.init(2,1)]) |> Vivid.Polygon.to_lines\n    [%Vivid.Line{origin: %Vivid.Point{x: 1, y: 1},\n       termination: %Vivid.Point{x: 1, y: 2}},\n     %Vivid.Line{origin: %Vivid.Point{x: 1, y: 2},\n       termination: %Vivid.Point{x: 2, y: 2}},\n     %Vivid.Line{origin: %Vivid.Point{x: 2, y: 2},\n       termination: %Vivid.Point{x: 2, y: 1}},\n     %Vivid.Line{origin: %Vivid.Point{x: 2, y: 1},\n       termination: %Vivid.Point{x: 1, y: 1}}]","ref":"Vivid.Polygon.html#to_lines/1-examples"},{"type":"type","title":"Vivid.Polygon.t/0","doc":"","ref":"Vivid.Polygon.html#t:t/0"},{"type":"module","title":"Vivid.RGBA","doc":"Defines a colour in RGBA colour space.\n\nThe three colour channels and the alpha channels are stored as numeric\nvalues between 0 and 1.","ref":"Vivid.RGBA.html"},{"type":"module","title":"Example - Vivid.RGBA","doc":"iex> use Vivid\n    ...> RGBA.black()\n    Vivid.RGBA.init(0, 0, 0, 1)\n    iex> RGBA.white()\n    Vivid.RGBA.init(1, 1, 1, 1)\n    iex> RGBA.init(1, 0, 0, 0.5)\n    Vivid.RGBA.init(1, 0, 0, 0.5)","ref":"Vivid.RGBA.html#module-example"},{"type":"function","title":"Vivid.RGBA.alpha/1","doc":"Return the alpha component of the colour.","ref":"Vivid.RGBA.html#alpha/1"},{"type":"function","title":"Example - Vivid.RGBA.alpha/1","doc":"iex> Vivid.RGBA.init(0.7, 0.6, 0.5, 0.4)\n    ...> |> Vivid.RGBA.alpha\n    0.4","ref":"Vivid.RGBA.html#alpha/1-example"},{"type":"function","title":"Vivid.RGBA.black/0","doc":"Shorthand for black.","ref":"Vivid.RGBA.html#black/0"},{"type":"function","title":"Example - Vivid.RGBA.black/0","doc":"iex> Vivid.RGBA.black\n    Vivid.RGBA.init(0, 0, 0, 1)","ref":"Vivid.RGBA.html#black/0-example"},{"type":"function","title":"Vivid.RGBA.blue/1","doc":"Return the blue component of the colour.","ref":"Vivid.RGBA.html#blue/1"},{"type":"function","title":"Example - Vivid.RGBA.blue/1","doc":"iex> Vivid.RGBA.init(0.7, 0.6, 0.5, 0.4)\n    ...> |> Vivid.RGBA.blue\n    0.5","ref":"Vivid.RGBA.html#blue/1-example"},{"type":"function","title":"Vivid.RGBA.green/1","doc":"Return the green component of the colour.","ref":"Vivid.RGBA.html#green/1"},{"type":"function","title":"Example - Vivid.RGBA.green/1","doc":"iex> Vivid.RGBA.init(0.7, 0.6, 0.5, 0.4)\n    ...> |> Vivid.RGBA.green\n    0.6","ref":"Vivid.RGBA.html#green/1-example"},{"type":"function","title":"Vivid.RGBA.init/3","doc":"Create a colour. Like magic.\n\n* `red` the red component of the colour.\n* `green` the green component of the colour.\n* `blue` the blue component of the colour.\n\nAll values are between zero and one.\n\nWhen the alpha argument is omitted it is assumed to be `1` (ie completely\nopaque).","ref":"Vivid.RGBA.html#init/3"},{"type":"function","title":"Example - Vivid.RGBA.init/3","doc":"iex> Vivid.RGBA.init(0.1, 0.2, 0.3, 0.4)\n    Vivid.RGBA.init(0.1, 0.2, 0.3, 0.4)","ref":"Vivid.RGBA.html#init/3-example"},{"type":"function","title":"Vivid.RGBA.init/4","doc":"Create a colour. Like magic.\n\n* `red` the red component of the colour.\n* `green` the green component of the colour.\n* `blue` the blue component of the colour.\n* `alpha` the opacity of the colour.\n\nAll values are between zero and one.","ref":"Vivid.RGBA.html#init/4"},{"type":"function","title":"Example - Vivid.RGBA.init/4","doc":"iex> Vivid.RGBA.init(0.1, 0.2, 0.3, 0.4)\n    Vivid.RGBA.init(0.1, 0.2, 0.3, 0.4)","ref":"Vivid.RGBA.html#init/4-example"},{"type":"function","title":"Vivid.RGBA.luminance/1","doc":"Return the luminance of a colour, using some colour mixing ratios I found\non stack exchange.","ref":"Vivid.RGBA.html#luminance/1"},{"type":"function","title":"Examples - Vivid.RGBA.luminance/1","doc":"iex> Vivid.RGBA.init(1,0,0) |> Vivid.RGBA.luminance\n    0.2128\n\n    iex> Vivid.RGBA.white |> Vivid.RGBA.luminance\n    1.0\n\n    iex> Vivid.RGBA.black |> Vivid.RGBA.luminance\n    0.0","ref":"Vivid.RGBA.html#luminance/1-examples"},{"type":"function","title":"Vivid.RGBA.over/2","doc":"Blend two colours together using their alpha information using the \"over\" algorithm.","ref":"Vivid.RGBA.html#over/2"},{"type":"function","title":"Examples - Vivid.RGBA.over/2","doc":"iex> Vivid.RGBA.over(Vivid.RGBA.black, Vivid.RGBA.init(1,1,1, 0.5))\n    Vivid.RGBA.init(0.5, 0.5, 0.5, 1.0)","ref":"Vivid.RGBA.html#over/2-examples"},{"type":"function","title":"Vivid.RGBA.red/1","doc":"Return the red component of the colour.","ref":"Vivid.RGBA.html#red/1"},{"type":"function","title":"Example - Vivid.RGBA.red/1","doc":"iex> Vivid.RGBA.init(0.7, 0.6, 0.5, 0.4)\n    ...> |> Vivid.RGBA.red\n    0.7","ref":"Vivid.RGBA.html#red/1-example"},{"type":"function","title":"Vivid.RGBA.to_ascii/1","doc":"Convert a colour to an ASCII character.\n\nThis isn't very scientific, but helps with debugging and is used in the\nimplementations of `String.Chars` for Vivid types.\n\nThe chacaters used (from black to white) are `\" .:-=+*#%@\"`. These are\nchosen based on the `luminance/1` value of the colour.","ref":"Vivid.RGBA.html#to_ascii/1"},{"type":"function","title":"Vivid.RGBA.to_hex/1","doc":"Convert a colour to HTML style hex.","ref":"Vivid.RGBA.html#to_hex/1"},{"type":"function","title":"Example - Vivid.RGBA.to_hex/1","doc":"iex> Vivid.RGBA.init(0.7, 0.6, 0.5)\n    ...> |> Vivid.RGBA.to_hex\n    \"#B39980\"","ref":"Vivid.RGBA.html#to_hex/1-example"},{"type":"function","title":"Vivid.RGBA.white/0","doc":"Shorthand for white.","ref":"Vivid.RGBA.html#white/0"},{"type":"function","title":"Example - Vivid.RGBA.white/0","doc":"iex> Vivid.RGBA.white\n    Vivid.RGBA.init(1, 1, 1, 1)","ref":"Vivid.RGBA.html#white/0-example"},{"type":"type","title":"Vivid.RGBA.t/0","doc":"","ref":"Vivid.RGBA.html#t:t/0"},{"type":"type","title":"Vivid.RGBA.zero_to_one/0","doc":"","ref":"Vivid.RGBA.html#t:zero_to_one/0"},{"type":"protocol","title":"Vivid.Rasterize","doc":"The Rasterize protocol is responsible for converting shapes into bitmaps.\n\nIf you're defining your own shape then you need to implement this protocol.","ref":"Vivid.Rasterize.html"},{"type":"protocol","title":"Example - Vivid.Rasterize","doc":"iex> use Vivid\n    ...> Box.init(Point.init(1,1), Point.init(4,4))\n    ...> |> Rasterize.rasterize(Bounds.init(0,0,5,5))\n    #MapSet , #Vivid.Point , #Vivid.Point , #Vivid.Point , #Vivid.Point , #Vivid.Point , #Vivid.Point , #Vivid.Point , #Vivid.Point , #Vivid.Point , #Vivid.Point , #Vivid.Point ]>","ref":"Vivid.Rasterize.html#module-example"},{"type":"function","title":"Vivid.Rasterize.rasterize/2","doc":"Convert a shape into a bitmap.\n\nTakes a `shape` and returns a `MapSet` of points within `bounds`.","ref":"Vivid.Rasterize.html#rasterize/2"},{"type":"type","title":"Vivid.Rasterize.t/0","doc":"All the types that implement this protocol.","ref":"Vivid.Rasterize.html#t:t/0"},{"type":"module","title":"Vivid.SLPFA","doc":"Scanline Polygon Filling Algorithm, as per\nhttps://hackernoon.com/computer-graphics-scan-line-polygon-fill-algorithm-3cb47283df6#.20fac9f40\n\nThis algorithm only fills the *inside* of a polygon, leaving you free to\nto compose it with the original polygon if you want to use different border\nand fill colours, for example.","ref":"Vivid.SLPFA.html"},{"type":"function","title":"Vivid.SLPFA.fill/1","doc":"Fills the inside area of a polygon using the Scanline Polygon Filling\nAlgorithm.","ref":"Vivid.SLPFA.html#fill/1"},{"type":"function","title":"Examples - Vivid.SLPFA.fill/1","doc":"The original polygon.\n\n    iex> use Vivid\n    ...> frame = Frame.init(16, 16, RGBA.black)\n    ...> polygon = Polygon.init([Point.init(1, 1), Point.init(4, 1), Point.init(4, 7), Point.init(11, 7), Point.init(11, 1), Point.init(14, 1), Point.init(14, 14), Point.init(1, 14)])\n    ...> Frame.push(frame, polygon, RGBA.white)\n    ...>   |> to_string\n    \"                \\n\"  \n    \" @@@@@@@@@@@@@@ \\n\"  \n    \" @            @ \\n\"  \n    \" @            @ \\n\"  \n    \" @            @ \\n\"  \n    \" @            @ \\n\"  \n    \" @            @ \\n\"  \n    \" @            @ \\n\"  \n    \" @  @@@@@@@@  @ \\n\"  \n    \" @  @      @  @ \\n\"  \n    \" @  @      @  @ \\n\"  \n    \" @  @      @  @ \\n\"  \n    \" @  @      @  @ \\n\"  \n    \" @  @      @  @ \\n\"  \n    \" @@@@      @@@@ \\n\"  \n    \"                \\n\"\n\nThe filled area of the polygon\n\n    iex> use Vivid\n    ...> frame = Frame.init(16, 16, RGBA.black)\n    ...> polygon = Polygon.init([Point.init(1, 1), Point.init(4, 1), Point.init(4, 7), Point.init(11, 7), Point.init(11, 1), Point.init(14, 1), Point.init(14, 14), Point.init(1, 14)]) |> Vivid.SLPFA.fill |> Group.init\n    ...> Frame.push(frame, polygon, RGBA.white)\n    ...>   |> to_string\n    \"                \\n\"  \n    \"                \\n\"  \n    \"  @@@@@@@@@@@@  \\n\"  \n    \"  @@@@@@@@@@@@  \\n\"  \n    \"  @@@@@@@@@@@@  \\n\"  \n    \"  @@@@@@@@@@@@  \\n\"  \n    \"  @@@@@@@@@@@@  \\n\"  \n    \"  @@@@@@@@@@@@  \\n\"  \n    \"  @@@@@@@@@@@@  \\n\"  \n    \"  @@        @@  \\n\"  \n    \"  @@        @@  \\n\"  \n    \"  @@        @@  \\n\"  \n    \"  @@        @@  \\n\"  \n    \"  @@        @@  \\n\"  \n    \"  @@        @@  \\n\"  \n    \"                \\n\"\n\nThe polygon and the fill combined.\n\n    iex> use Vivid\n    ...> frame = Frame.init(16, 16, RGBA.black)\n    ...> polygon = Polygon.init([Point.init(1, 1), Point.init(4, 1), Point.init(4, 7), Point.init(11, 7), Point.init(11, 1), Point.init(14, 1), Point.init(14, 14), Point.init(1, 14)])\n    ...> inside = polygon |> Vivid.SLPFA.fill |> Group.init\n    ...> Frame.push(frame, polygon, RGBA.white)\n    ...>   |> Frame.push(inside, RGBA.white)\n    ...>   |> to_string\n    \"                \\n\"  \n    \" @@@@@@@@@@@@@@ \\n\"  \n    \" @@@@@@@@@@@@@@ \\n\"  \n    \" @@@@@@@@@@@@@@ \\n\"  \n    \" @@@@@@@@@@@@@@ \\n\"  \n    \" @@@@@@@@@@@@@@ \\n\"  \n    \" @@@@@@@@@@@@@@ \\n\"  \n    \" @@@@@@@@@@@@@@ \\n\"  \n    \" @@@@@@@@@@@@@@ \\n\"  \n    \" @@@@      @@@@ \\n\"  \n    \" @@@@      @@@@ \\n\"  \n    \" @@@@      @@@@ \\n\"  \n    \" @@@@      @@@@ \\n\"  \n    \" @@@@      @@@@ \\n\"  \n    \" @@@@      @@@@ \\n\"  \n    \"                \\n\"","ref":"Vivid.SLPFA.html#fill/1-examples"},{"type":"module","title":"Vivid.Shape","doc":"Doesn't do anything - is merely a type to represent an arbitrary shape in typespecs.","ref":"Vivid.Shape.html"},{"type":"type","title":"Vivid.Shape.t/0","doc":"","ref":"Vivid.Shape.html#t:t/0"},{"type":"module","title":"Vivid.ShapeToString","doc":"Handle conversions of arbitrary shapes into strings.","ref":"Vivid.ShapeToString.html"},{"type":"function","title":"Vivid.ShapeToString.to_string/1","doc":"Convert a `shape` into a `string` for `IO.puts`, etc.","ref":"Vivid.ShapeToString.html#to_string/1"},{"type":"module","title":"Vivid.Transform","doc":"Creates and applies a \"pipeline\" of transformations to a shape.\nTransformation operations are collected up and only run once, when `apply` is called.","ref":"Vivid.Transform.html"},{"type":"module","title":"Examples - Vivid.Transform","doc":"Take a square, rotate it 45°, scale it up 50% and center it within a frame.\n\n    iex> use Vivid\n    ...> frame = Frame.init(40, 40, RGBA.white)\n    ...> box = Box.init(Point.init(0,0), Point.init(10,10))\n    ...>   |> Transform.rotate(45)\n    ...>   |> Transform.scale(1.5)\n    ...>   |> Transform.center(frame)\n    ...>   |> Transform.apply\n    ...> Frame.push(frame, box, RGBA.black)\n    ...> |> to_string\n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@ @@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@ @ @@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@ @@@ @@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@ @@@@@ @@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@ @@@@@@@ @@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@  @@@@@@@@@ @@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@ @@@@@@@@@@@@ @@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@ @@@@@@@@@@@@@@ @@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@ @@@@@@@@@@@@@@@@ @@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@ @@@@@@@@@@@@@@@@@@ @@@@@@@@@@\\n\"  \n    \"@@@@@@@@@ @@@@@@@@@@@@@@@@@@@@ @@@@@@@@@\\n\"  \n    \"@@@@@@@@@@ @@@@@@@@@@@@@@@@@@ @@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@ @@@@@@@@@@@@@@@@ @@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@ @@@@@@@@@@@@@@ @@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@ @@@@@@@@@@@@ @@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@ @@@@@@@@@@ @@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@ @@@@@@@@@ @@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@ @@@@@@@ @@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@ @@@@@ @@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@ @@@ @@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@ @ @@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@ @@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\\n\"","ref":"Vivid.Transform.html#module-examples"},{"type":"function","title":"Vivid.Transform.apply/1","doc":"Apply a transformation pipeline returning the modified shape.","ref":"Vivid.Transform.html#apply/1"},{"type":"function","title":"Vivid.Transform.center/2","doc":"Center a shape within the specified bounds.","ref":"Vivid.Transform.html#center/2"},{"type":"function","title":"Examples - Vivid.Transform.center/2","doc":"iex> use Vivid\n    ...> frame = Frame.init(13,13, RGBA.white)\n    ...> box = Box.init(Point.init(10,10), Point.init(20,20))\n    ...>   |> Vivid.Transform.center(Bounds.init(0, 0, 12, 12))\n    ...>   |> Vivid.Transform.apply\n    ...> Frame.push(frame, box, RGBA.black)\n    ...> |> to_string\n    \"@@@@@@@@@@@@@\\n\"  \n    \"@           @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@ @@@@@@@@@ @\\n\"  \n    \"@           @\\n\"  \n    \"@@@@@@@@@@@@@\\n\"","ref":"Vivid.Transform.html#center/2-examples"},{"type":"function","title":"Vivid.Transform.fill/2","doc":"Scale a shape to the maximum size within bounds, respecting the shape's aspect ratio.","ref":"Vivid.Transform.html#fill/2"},{"type":"function","title":"Examples - Vivid.Transform.fill/2","doc":"iex> Vivid.Box.init(Vivid.Point.init(10,10), Vivid.Point.init(20,20))\n    ...> |> Vivid.Transform.fill(Vivid.Bounds.init(0, 0, 40, 80))\n    ...> |> Vivid.Transform.apply\n    Vivid.Polygon.init([Vivid.Point.init(40.0, 0.0), Vivid.Point.init(40.0, 40.0), Vivid.Point.init(0.0, 40.0), Vivid.Point.init(0.0, 0.0)])","ref":"Vivid.Transform.html#fill/2-examples"},{"type":"function","title":"Vivid.Transform.overflow/2","doc":"Scale a shape to completely fill bounds, respecting the shape's aspect ratio.\nThus overflowing the bounds if the shape's aspect ratio doesn't match that of the bounds.","ref":"Vivid.Transform.html#overflow/2"},{"type":"function","title":"Examples - Vivid.Transform.overflow/2","doc":"iex> Vivid.Box.init(Vivid.Point.init(10,10), Vivid.Point.init(20,20))\n    ...> |> Vivid.Transform.overflow(Vivid.Bounds.init(0, 0, 40, 80))\n    ...> |> Vivid.Transform.apply\n    Vivid.Polygon.init([Vivid.Point.init(80.0, 0.0), Vivid.Point.init(80.0, 80.0), Vivid.Point.init(0.0, 80.0), Vivid.Point.init(0.0, 0.0)])","ref":"Vivid.Transform.html#overflow/2-examples"},{"type":"function","title":"Vivid.Transform.rotate/2","doc":"Rotate a shape around it's center point.","ref":"Vivid.Transform.html#rotate/2"},{"type":"function","title":"Example - Vivid.Transform.rotate/2","doc":"iex> Vivid.Box.init(Vivid.Point.init(10,10), Vivid.Point.init(20,20))\n    ...> |> Vivid.Transform.rotate(45)\n    ...> |> Vivid.Transform.apply\n    ...> |> to_string\n    \"@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@ @@@@@@@@\\n\"  \n    \"@@@@@@@ @ @@@@@@@\\n\"  \n    \"@@@@@@ @@@ @@@@@@\\n\"  \n    \"@@@@@ @@@@@ @@@@@\\n\"  \n    \"@@@@ @@@@@@@ @@@@\\n\"  \n    \"@@@ @@@@@@@@@ @@@\\n\"  \n    \"@@ @@@@@@@@@@@ @@\\n\"  \n    \"@ @@@@@@@@@@@@@ @\\n\"  \n    \"@@ @@@@@@@@@@@ @@\\n\"  \n    \"@@@ @@@@@@@@@ @@@\\n\"  \n    \"@@@@ @@@@@@@ @@@@\\n\"  \n    \"@@@@@ @@@@@ @@@@@\\n\"  \n    \"@@@@@@ @@@ @@@@@@\\n\"  \n    \"@@@@@@@ @ @@@@@@@\\n\"  \n    \"@@@@@@@@ @@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@\\n\"","ref":"Vivid.Transform.html#rotate/2-example"},{"type":"function","title":"Vivid.Transform.rotate/3","doc":"Rotate a shape around an origin point.","ref":"Vivid.Transform.html#rotate/3"},{"type":"function","title":"Example - Vivid.Transform.rotate/3","doc":"iex> Vivid.Box.init(Vivid.Point.init(10,10), Vivid.Point.init(20,20))\n    ...> |> Vivid.Transform.rotate(45, Vivid.Point.init(5,5))\n    ...> |> Vivid.Transform.apply\n    ...> |> to_string\n    \"@@@@@@@@@@@@@@@@@\\n\"  \n    \"@@@@@@@@ @@@@@@@@\\n\"  \n    \"@@@@@@@ @ @@@@@@@\\n\"  \n    \"@@@@@@ @@@ @@@@@@\\n\"  \n    \"@@@@@ @@@@@ @@@@@\\n\"  \n    \"@@@@ @@@@@@@ @@@@\\n\"  \n    \"@@@ @@@@@@@@@ @@@\\n\"  \n    \"@@ @@@@@@@@@@@ @@\\n\"  \n    \"@ @@@@@@@@@@@@@ @\\n\"  \n    \"@@ @@@@@@@@@@@ @@\\n\"  \n    \"@@@ @@@@@@@@@ @@@\\n\"  \n    \"@@@@ @@@@@@@ @@@@\\n\"  \n    \"@@@@@ @@@@@ @@@@@\\n\"  \n    \"@@@@@@ @@@ @@@@@@\\n\"  \n    \"@@@@@@@ @ @@@@@@@\\n\"  \n    \"@@@@@@@@ @@@@@@@@\\n\"  \n    \"@@@@@@@@@@@@@@@@@\\n\"","ref":"Vivid.Transform.html#rotate/3-example"},{"type":"function","title":"Vivid.Transform.scale/2","doc":"Uniformly scale a `shape` around it's center point.","ref":"Vivid.Transform.html#scale/2"},{"type":"function","title":"Examples - Vivid.Transform.scale/2","doc":"iex> Vivid.Box.init(Vivid.Point.init(5,5), Vivid.Point.init(10,10))\n    ...> |> Vivid.Transform.scale(2)\n    ...> |> Vivid.Transform.apply\n    Vivid.Polygon.init([Vivid.Point.init(12.5, 2.5), Vivid.Point.init(12.5, 12.5), Vivid.Point.init(2.5, 12.5), Vivid.Point.init(2.5, 2.5)])","ref":"Vivid.Transform.html#scale/2-examples"},{"type":"function","title":"Vivid.Transform.scale/3","doc":"Scale a `shape` around it's center point using the given `x` and `y` multipliers.","ref":"Vivid.Transform.html#scale/3"},{"type":"function","title":"Examples - Vivid.Transform.scale/3","doc":"iex> Vivid.Box.init(Vivid.Point.init(5,5), Vivid.Point.init(10,10))\n    ...> |> Vivid.Transform.scale(2, 4)\n    ...> |> Vivid.Transform.apply\n    Vivid.Polygon.init([Vivid.Point.init(12.5, -2.5), Vivid.Point.init(12.5, 17.5), Vivid.Point.init(2.5, 17.5), Vivid.Point.init(2.5, -2.5)])","ref":"Vivid.Transform.html#scale/3-examples"},{"type":"function","title":"Vivid.Transform.stretch/2","doc":"Stretch a shape to the maximum size within bounds, ignoring the shape's original aspect ratio.","ref":"Vivid.Transform.html#stretch/2"},{"type":"function","title":"Examples - Vivid.Transform.stretch/2","doc":"iex> Vivid.Box.init(Vivid.Point.init(10,10), Vivid.Point.init(20,20))\n    ...> |> Vivid.Transform.stretch(Vivid.Bounds.init(0, 0, 40, 80))\n    ...> |> Vivid.Transform.apply\n    Vivid.Polygon.init([Vivid.Point.init(40.0, 0.0), Vivid.Point.init(40.0, 80.0), Vivid.Point.init(0.0, 80.0), Vivid.Point.init(0.0, 0.0)])","ref":"Vivid.Transform.html#stretch/2-examples"},{"type":"function","title":"Vivid.Transform.transform/2","doc":"Create an arbitrary transformation.\n\nTakes a shape and a function which is called with a shape argument (not necessarily the shape\npassed-in, depending on where this transformation is in the transformation pipeline).\n\nThe function must return another function which takes and manipulates a point.","ref":"Vivid.Transform.html#transform/2"},{"type":"function","title":"Example - Vivid.Transform.transform/2","doc":"The example below translates a point right by half it's width.\n\n    iex> Vivid.Box.init(Vivid.Point.init(10,10), Vivid.Point.init(20,20))\n    ...> |> Vivid.Transform.transform(fn shape ->\n    ...>   width = Vivid.Bounds.width(shape)\n    ...>   fn point ->\n    ...>     x = point |> Vivid.Point.x\n    ...>     y = point |> Vivid.Point.y\n    ...>     x = x + (width / 2) |> round\n    ...>     Vivid.Point.init(x, y)\n    ...>   end\n    ...> end)\n    ...> |> Vivid.Transform.apply\n    Vivid.Polygon.init([Vivid.Point.init(25, 10), Vivid.Point.init(25, 20), Vivid.Point.init(15, 20), Vivid.Point.init(15, 10)])","ref":"Vivid.Transform.html#transform/2-example"},{"type":"function","title":"Vivid.Transform.translate/3","doc":"Translate (ie move) a shape by adding `x` and `y` to each Point.","ref":"Vivid.Transform.html#translate/3"},{"type":"function","title":"Example - Vivid.Transform.translate/3","doc":"iex> Vivid.Box.init(Vivid.Point.init(5,5), Vivid.Point.init(10,10))\n    ...> |> Vivid.Transform.translate(5, 5)\n    ...> |> Vivid.Transform.apply\n    Vivid.Polygon.init([Vivid.Point.init(15, 10), Vivid.Point.init(15, 15), Vivid.Point.init(10, 15), Vivid.Point.init(10, 10)])","ref":"Vivid.Transform.html#translate/3-example"},{"type":"type","title":"Vivid.Transform.degrees/0","doc":"","ref":"Vivid.Transform.html#t:degrees/0"},{"type":"type","title":"Vivid.Transform.shape_or_transform/0","doc":"","ref":"Vivid.Transform.html#t:shape_or_transform/0"},{"type":"type","title":"Vivid.Transform.t/0","doc":"","ref":"Vivid.Transform.html#t:t/0"},{"type":"module","title":"Vivid.Transform.Operation","doc":"An operation that can be applied to a shape.","ref":"Vivid.Transform.Operation.html"},{"type":"type","title":"Vivid.Transform.Operation.t/0","doc":"","ref":"Vivid.Transform.Operation.html#t:t/0"},{"type":"module","title":"Vivid.Transform.Point","doc":"Standard transformations which can be applied to points without\nknowing the details of the geometry.\n\nUsed extensively by `Transform`, however you can use these functions\nas input to the `Transformable` protocol, should you require.","ref":"Vivid.Transform.Point.html"},{"type":"function","title":"Vivid.Transform.Point.rotate/3","doc":"Rotate `point` `degrees` around an `origin` point.","ref":"Vivid.Transform.Point.html#rotate/3"},{"type":"function","title":"Vivid.Transform.Point.rotate_radians/3","doc":"Rotate `point` `radians` around an `origin` point.","ref":"Vivid.Transform.Point.html#rotate_radians/3"},{"type":"function","title":"Vivid.Transform.Point.scale/3","doc":"Scale `point` (ie move it) by multiplying it's distance from the `0`, `0` point by `x_factor` and `y_factor`.","ref":"Vivid.Transform.Point.html#scale/3"},{"type":"function","title":"Vivid.Transform.Point.scale/4","doc":"Scale `point` (ie move it) by multiplying it's distance from the origin point by `x_factor` and `y_factor`.","ref":"Vivid.Transform.Point.html#scale/4"},{"type":"function","title":"Vivid.Transform.Point.translate/3","doc":"Translate `point` (ie move it) by adding `x` and `y` to it's coordinates.","ref":"Vivid.Transform.Point.html#translate/3"},{"type":"type","title":"Vivid.Transform.Point.degrees/0","doc":"","ref":"Vivid.Transform.Point.html#t:degrees/0"},{"type":"type","title":"Vivid.Transform.Point.radians/0","doc":"","ref":"Vivid.Transform.Point.html#t:radians/0"},{"type":"protocol","title":"Vivid.Transformable","doc":"This protocol is used to apply *point* transformations to a shape.","ref":"Vivid.Transformable.html"},{"type":"function","title":"Vivid.Transformable.transform/2","doc":"Transform all of a shape's points using `fun`.","ref":"Vivid.Transformable.html#transform/2"},{"type":"type","title":"Vivid.Transformable.t/0","doc":"All the types that implement this protocol.","ref":"Vivid.Transformable.html#t:t/0"},{"type":"extras","title":"Getting Started with Vivid","doc":"# Getting Started with Vivid\n\nVivid is designed to be as straightforward to use as possible whilst still providing enough features to be useful.  It was originally concieved for displaying graphics and text on [Monochrome 1.3\" 128x64 OLED graphic display from Adafruit](https://www.adafruit.com/products/938), which it does.\n\n![4 x OLED display clock using Hershey vector fonts](https://raw.githubusercontent.com/jamesotron/vivid.ex/master/guides/images/vivid_clock.jpg)\n\nThe scope quickly expanded to include arbitrary transforms, basic colour compositing and alpha channels.  I even added [`vivid_png`](https://github.com/jamesotron/vivid_png.ex) for writing out PNG files.","ref":"getting-started.html"},{"type":"extras","title":"Adding `vivid` to your app - Getting Started with Vivid","doc":"Edit your `mix.exs` and add [the current version of `vivid`](https://hex.pm/packages/vivid) to your `dependencies` list.\n\nIf you want to be able to render PNG files then you also want to add\n[`vivid_png`](https://hex.pm/packages/vivid_png).","ref":"getting-started.html#adding-vivid-to-your-app"},{"type":"extras","title":"General principals - Getting Started with Vivid","doc":"Vivid tries to consistently reuse a bunch of principals thoughout the code base;\n\n  * All \"shape\" types, e.g. boxes, circles and polygons have an `init` function which will generate the shape with as many sane defaults as possible.  The corresponding modules also contain functions for manipulating the contents of the shape without needing to know the internal structure of the type.  Vivid discourages the use of type structs directly as these are subject to change.\n\n  * Most of the stuff you want to *do* with shapes, like render, transform or measure are implemented with Elixir protocols, meaning you can define your own shape types as required.\n\n  * The `String.Chars` protocol has been implemented everywhere it makes sense, so that you can easily debug by just calling `to_string/1` or `IO.puts/1` on almost any type.\n\n  * If you `use Vivid` at the top of your module it will automatically add aliases for all the core Vivid types into your local namespace. This can save a lot of typing, but otherwise doesn't do much.","ref":"getting-started.html#general-principals"},{"type":"extras","title":"Basic shapes - Getting Started with Vivid","doc":"Vivid implements a number of basic geometric primitives upon which you can compose your own shapes as needed.\n\n#","ref":"getting-started.html#basic-shapes"},{"type":"extras","title":"Point - Getting Started with Vivid","doc":"The most basic type is the [`Point`](https://hexdocs.pm/vivid/Vivid.Point.html#content), which represents a location in 2 dimensional cartesian space (ie `x` and `y` offset).\n\n    iex> use Vivid\n    ...> Point.init(13, 27)\n    #Vivid.Point \n![point example](https://raw.githubusercontent.com/jamesotron/vivid.ex/master/guides/images/point_example.png)\n\n#","ref":"getting-started.html#point"},{"type":"extras","title":"Line - Getting Started with Vivid","doc":"A [Line](https://hexdocs.pm/vivid/Vivid.Line.html#content) represents a straight line between to points, called `origin` and `termination` in Vivid parlance.\n\n`Line` implements the `Enumerable` protocol.\n\n    iex> use Vivid\n    ...> Line.init(Point.init(13,27), Point.init(2,3))\n    #Vivid.Line , termination: #Vivid.Point ]>\n![line example](https://raw.githubusercontent.com/jamesotron/vivid.ex/master/guides/images/line_example.png)\n\n#","ref":"getting-started.html#line"},{"type":"extras","title":"Path - Getting Started with Vivid","doc":"A [Path](https://hexdocs.pm/vivid/Vivid.Path.html#content) represents an aribitrary number of vertices (points) with lines connecting them.  A Path is different to a Polygon in that a Polygon is closed and a Path is open.\n\nA Path must consist of at least two vertices.\n\n`Path` implements the `Enumerable` and `Collectable` protocols so that you can use `Enum` and `Stream` to manipulate it.\n\n    iex> use Vivid\n    ...> Path.init([Point.init(13,27), Point.init(2,3), Point.init(27,13)])\n    #Vivid.Path , #Vivid.Point , #Vivid.Point ]>\n\n![path example](https://raw.githubusercontent.com/jamesotron/vivid.ex/master/guides/images/path_example.png)\n\n#","ref":"getting-started.html#path"},{"type":"extras","title":"Polygon - Getting Started with Vivid","doc":"A [Polygon](https://hexdocs.pm/vivid/Vivid.Polygon.html#content) also represents an arbitrary number of vertices (points) with lines connecting them, however a Polygon is a closed shape.  As such, polygon's must have at least three vertices.\n\n`Polygon` implements the `Enumerable` and `Collectable` protocols so that you can use `Enum` and `Stream` to manipulate it.\n\n    iex> use Vivid\n    ...> Polygon.init([Point.init(13,27), Point.init(2,3), Point.init(27,13)])\n    #Vivid.Polygon , #Vivid.Point , #Vivid.Point ]>\n\n![polygon example](https://raw.githubusercontent.com/jamesotron/vivid.ex/master/guides/images/polygon_example.png)\n\n#","ref":"getting-started.html#polygon"},{"type":"extras","title":"Box - Getting Started with Vivid","doc":"A [Box](https://hexdocs.pm/vivid/Vivid.Box.html#content) is a special kind of Polygon where there are exactly four vertices and two lines are horizontal and two lines are vertical, i.e. a rectangle. But you knew that.\n\nBecause of the regular nature of rectangles they can be defined with only two points.  The first being the lower left corner and the second being the top right corner.\n\n    iex> use Vivid\n    ...> Box.init(Point.init(2,3), Point.init(13,27))\n    #Vivid.Box , top_right: #Vivid.Point ]>\n\n![box example](https://raw.githubusercontent.com/jamesotron/vivid.ex/master/guides/images/box_example.png)\n\n#","ref":"getting-started.html#box"},{"type":"extras","title":"Circle - Getting Started with Vivid","doc":"I'm sure you know what a [Circle](https://hexdocs.pm/vivid/Vivid.Circle.html#content) is.  It is initialised using a center point and a radius.\n\nCircles are converted to polygons when transforming or rendering, so you can't always rely on being able to use the `Circle` API to manipulate existing shapes.\n\nOften it may be necessary to convert it to a polygon manually before rendering so that you can control the number of vertices in the generated polygon.\n\n    iex> use Vivid\n    ...> Circle.init(Point.init(15,15), 10)\n    #Vivid.Circle , radius: 10]>\n\n![circle example](https://raw.githubusercontent.com/jamesotron/vivid.ex/master/guides/images/circle_example.png)\n\n#","ref":"getting-started.html#circle"},{"type":"extras","title":"Arc - Getting Started with Vivid","doc":"An [Arc](https://hexdocs.pm/vivid/Vivid.Arc.html#content), also known as a circle segment is a slice of a circle and initialised with a center point and radius much like a circle, however you also provide a start angle and a range (both in degrees) of arc that you wish to render.\n\nArcs are converted to paths when transforming or rendering, so you can't always rely on being able to use the `Arc` API to manipulate existing shapes.\n\nYou can optionally also specify the number of steps used during path generation in the initialiser.\n\n    iex> use Vivid\n    ...> Arc.init(Point.init(15,15), 45, 90)\n    #Vivid.Arc , radius: 10, start_angle: 45, range: 90, steps: 12]>\n\n![arc example](https://raw.githubusercontent.com/jamesotron/vivid.ex/master/guides/images/arc_example.png)\n\n#","ref":"getting-started.html#arc"},{"type":"extras","title":"Group - Getting Started with Vivid","doc":"A [Group](https://hexdocs.pm/vivid/Vivid.Group.html#content) allows for arbitrary composition of shapes into a single data structure.  It's not so much a shape itself, as a collection of other shapes.\n\n`Group` also implements the `Enumerable` and `Collectable` protocols so that you can use `Enum` and `Stream` to create them.\n\n    iex> use Vivid\n    ...> box = Box.init(Point.init(2,3), Point.init(13,27))\n    ...> circle = Circle.init(Point.init(15,15), 10)\n    ...> Group.init([box, circle])\n    #Vivid.Group , top_right: #Vivid.Point ]>, #Vivid.Circle , radius: 10]>]>\n\n![group example](https://raw.githubusercontent.com/jamesotron/vivid.ex/master/guides/images/group_example.png)","ref":"getting-started.html#group"},{"type":"extras","title":"Colours - Getting Started with Vivid","doc":"Vivid (currently) defines all colours in terms of the RGBA colourspace.  Create a new colour by passing red, green, blue and opacity values as integers or floats between `0` and `1`.\n\n    iex> use Vivid\n    ...> RGBA.init(0.75, 0.25, 0.5, 0.8)\n    #Vivid.RGBA \n\n![rgba example](https://raw.githubusercontent.com/jamesotron/vivid.ex/master/guides/images/rgba_example.png)","ref":"getting-started.html#colours"},{"type":"extras","title":"Compositing - Getting Started with Vivid","doc":"When you place two shapes on a buffer which overlap and where transparency is involved Vivid will use the \"over\" colour compositing algorithm.  See [Wikipedia's article on alpha compositing](https://en.wikipedia.org/wiki/Alpha_compositing) for more information.\n\n#","ref":"getting-started.html#compositing"},{"type":"extras","title":"Frame - Getting Started with Vivid","doc":"A [Frame](https://hexdocs.pm/vivid/Vivid.Frame.html#content) stores a stack of shapes and corresponding colours and is the only type that can truly be rendered into a buffer.\n\nShapes and colours are pushed onto the frame in pairs, and composited during the render pass.  `Frame` also implements the `Enumerable` and `Collectable` procotols meaning that you can use the `Enum` and `Stream` module to build frames.\n\nFrames can be converted to buffers, which are the fully-rendered bitmap output, which is what you'll likely want to use for display.\n\n    iex> use Vivid\n    ...> Frame.init(30, 30, RGBA.init(1,0,0,1))\n    #Vivid.Frame ]>\n\n#","ref":"getting-started.html#frame"},{"type":"extras","title":"Buffer - Getting Started with Vivid","doc":"A [Buffer](https://hexdocs.pm/vivid/Vivid.Buffer.html#content) is used to render the contents of a `Frame` into a bitmap which can be displayed. `Buffer` implements the `Enumerable` protocol and emits a list of `RGBA` colours.\n\n    iex> use Vivid\n    ...> Frame.init(30, 30, RGBA.init(1,0,0,1))\n    ...> |> Buffer.horizontal()\n    #Vivid.Buffer","ref":"getting-started.html#buffer"}],"content_type":"text/markdown"}